<NodesDefinition>
<config  field_mand="name, descr, size" />
<config  field_attr="name" type="ascii" />
<config  field_attr="descr" type="ascii" />
<config  field_attr="size" type="hexa" />
<config  field_attr="type" type="ascii" />
<config  field_attr="rw" type="enum" >
	<enum  name="OP" value="OP" />
	<enum  name="ReadOnly" value="RO" />
	<enum  name="ReadWrite" value="RW" />
	<enum  name="WriteOnly" value="WO" />
</config>
<config  field_attr="access" type="enum" >
	<enum  name="Index" value="INDEX" />
	<enum  name="OP" value="OP" />
	<enum  name="ReadOnly" value="RO" />
	<enum  name="ReadWrite" value="RW" />
	<enum  name="WriteOnly" value="WO" />
</config>
<config  field_attr="enum" type="enumval" />
<config  big_endian_arr="1" />
<config  field_attr="selected_by" type="ascii" used_for="node" />
<config  field_attr="union_selector" type="ascii" used_for="node" />
<config  field_attr="mlxconfig_desc" type="ascii" />
<config  field_attr="mlxconfig_name" type="ascii" />
<config  field_attr="xuefi" type="ascii" />
<config  field_attr="supported_from_version" type="ascii" />
<config  field_attr="dependency" type="ascii" />
<config  field_attr="valid_bit" type="ascii" />
<config  field_attr="tempvars" type="ascii" />
<config  field_attr="minval" type="ascii" />
<config  field_attr="maxval" type="ascii" />
<config  field_attr="rule" type="ascii" />
<config  field_attr="regex" type="ascii" />
<config  field_attr="capability" type="ascii" />
<config  field_attr="target" type="ascii" />
<config  field_attr="version" type="ascii" />
<info source_doc_name="" source_doc_version="Rev 0.007" />
<node name="MICM_ext" descr="" size="0x28.0" >
	<field name="interrupts_mask" descr="Interrupts Mask\;When bit is set, the interrupt is enabled\;bit0: Thermal" access="RW" high_bound="7" low_bound="0" offset="0x4.0" size="0x20.0" />
</node>

<node name="MICV_ext" descr="" size="0x24.0" >
	<field name="op" descr="Operation\;0: Read\;1: Read and clear" access="OP" offset="0x0.0" size="0x0.4" />
	<field name="int_vec" descr="Interrupts Vector\;bit0: Thermal. For more info read also Table 159, &quot;MTEWE - Management Temperature Extended Warning Event Register Layout,&quot; on page 181\;bit1: Ready for PVS setting\;bit2-255: Reserved" access="RO" high_bound="7" low_bound="0" offset="0x4.0" size="0x20.0" />
</node>

<node name="MRFV_PVS_ext" descr="" size="0x4.0" >
	<field name="pvs_data_index" descr="PVS Data\;Process Sigma = -4 + 0.5 * cvb_data_index\;cvb_data_index valid values 0 .. 16\;For ArcusE\;Process Sigma &lt;-&gt; DVDD (mV)\;-4.0: 856.00\;-3.5: 847.75\;-3.0: 839.50\;-2.5: 831.25\;-2.0: 823.00\;-1.5: 814.75\;-1.0: 806.50\;-0.5: 798.25\;0 (nominal): 790.00\;0.5: 781.75\;1.0: 773.50\;1.5: 765.25\;2.0: 757.00\;2.5: 748.75\;3.0: 740.50\;3.5: 732.25\;4.0: 724.00" access="RO" offset="0x0.0" size="0x0.5" />
</node>

<node name="MRFV_ULT_ext" descr="" size="0xc.0" >
	<field name="ult_data" descr="ULT Data" access="RO" high_bound="2" low_bound="0" offset="0x0.0" size="0xc.0" />
</node>

<node name="MRFV_data_auto_ext" descr="" attr_is_union="1" size="0xc.0" >
	<field name="MRFV_PVS_ext" descr="" subnode="MRFV_PVS_ext" offset="0x0.0" selected_by="PVS_Values" size="0x4.0" />
	<field name="MRFV_ULT_ext" descr="" subnode="MRFV_ULT_ext" offset="0x0.0" selected_by="ULT" size="0xc.0" />
</node>

<node name="MRFV_ext" descr="" size="0x40.0" >
	<field name="fuse_id" descr="Fuse Index\;0: PVS_Values\;1: ULT\;Reserved when fm = 1" access="INDEX" enum="PVS_Values=0x0,ULT=0x1" offset="0x0.0" size="0x0.16" />
	<field name="fm" descr="Fuse Mismatch\;0: No fuse mismatch\;1: Fuse mismatch found\;2-3: Reserved" access="RO" offset="0x0.24" size="0x0.2" />
	<field name="v" descr="Valid bit\;0: Fuse reading is not supported for this system\;1: Response is valid\;2-3: Reserved\;Reserved when fm = 1" access="RO" offset="0x0.30" size="0x0.2" />
	<field name="data" descr="Data\;See Table 265, &quot;MRFV entry - PVS Layout,&quot; on page 253\;See Table 267, &quot;MRFV entry - ULT Layout,&quot; on page 254\;Reserved when fm = 1" subnode="MRFV_data_auto_ext" access="RO" offset="0x10.0" size="0xc.0" union_selector="$(parent).fuse_id" />
</node>

<node name="access_reg_summary_ctrl_ext" descr="" attr_is_union="1" size="0x4.0" >
	<field name="id" descr="" subnode="enum_entry" enum="SLTP=0x5027,SLRG=0x5028,PEMI=0x506e,MGCR=0x903a,MJTAG=0x901f,MICV=0x917a,MICM=0x917b,MTECR=0x9109,MTMP=0x900a,MTEWE=0x910b,MRSR=0x9023,MRSI=0x912a,MCQS=0x9060,MCQI=0x9061,MCC=0x9062,MCDA=0x9063,MQIS=0x9064,MGIR=0x9020,MSGI=0x9021,MDIR=0x911a,MCAM=0x907f,MECCC=0x905f,MRFV=0x906d,MDSR=0x9110,MFSV=0x9115,MTCQ=0x9065,MQDIK=0x9116,MKDC=0x9066,RTCAP=0x6c7f,RTCC=0x6c03,RTDPC=0x6c08,RTEDC=0x6c04,RTPSL=0x6c06,RTPTYS=0x6d00,RTPAOS=0x6d01,RTSFC=0x6d02,RTPTPR=0x6d20,RTTSPC=0x6d21,RTLTC=0x6d22,RTCDE=0x6d23,RTFCR=0x6d24,RTPPLR=0x6d30,RTPPRT=0x6d31,RTPPTT=0x6d32,RTPCNT=0x6d33,RTDSM=0x6d34" offset="0x0.0" size="0x4.0" />
</node>

<node name="access_reg_summary_ext" descr="" attr_is_union="1" size="0x208" >
	<field name="sltp_reg" descr="" subnode="sltp_reg_ext" capability="0" offset="0x0.0" selected_by="SLTP" size="0x4c" />
	<field name="slrg_reg" descr="" subnode="slrg_reg_ext" capability="0" offset="0x0.0" selected_by="SLRG" size="0x28" />
	<field name="pemi" descr="" subnode="pemi_ext" capability="0" offset="0x0.0" selected_by="PEMI" size="0x100" />
	<field name="mgcr_reg" descr="" subnode="mgcr_reg_ext" capability="0" offset="0x0.0" selected_by="MGCR" size="0x20" />
	<field name="mjtag" descr="" subnode="mjtag_ext" capability="0" offset="0x0.0" selected_by="MJTAG" size="0x30" />
	<field name="MICV" descr="" subnode="MICV_ext" capability="0" offset="0x0.0" selected_by="MICV" size="0x24" />
	<field name="MICM" descr="" subnode="MICM_ext" capability="0" offset="0x0.0" selected_by="MICM" size="0x28" />
	<field name="mtecr" descr="" subnode="mtecr_ext" capability="0" offset="0x0.0" selected_by="MTECR" size="0x60" />
	<field name="mtmp" descr="" subnode="mtmp_ext" capability="0" offset="0x0.0" selected_by="MTMP" size="0x20" />
	<field name="mtewe" descr="" subnode="mtewe_ext" capability="0" offset="0x0.0" selected_by="MTEWE" size="0x5c" />
	<field name="mrsr" descr="" subnode="mrsr_ext" capability="0" offset="0x0.0" selected_by="MRSR" size="0x8" />
	<field name="mrsi" descr="" subnode="mrsi_ext" capability="0" offset="0x0.0" selected_by="MRSI" size="0x40" />
	<field name="mcqs_reg" descr="" subnode="mcqs_reg_ext" capability="0" offset="0x0.0" selected_by="MCQS" size="0x10" />
	<field name="mcqi_reg" descr="" subnode="mcqi_reg_ext" capability="0" offset="0x0.0" selected_by="MCQI" size="0x94" />
	<field name="mcc_reg" descr="" subnode="mcc_reg_ext" capability="0" offset="0x0.0" selected_by="MCC" size="0x20" />
	<field name="mcda_reg" descr="" subnode="mcda_reg_ext" capability="0" offset="0x0.0" selected_by="MCDA" size="0x90" />
	<field name="mqis_reg" descr="" subnode="mqis_reg_ext" capability="0" offset="0x0.0" selected_by="MQIS" size="0x18" />
	<field name="mgir" descr="" subnode="mgir_ext" capability="0" offset="0x0.0" selected_by="MGIR" size="0xa0" />
	<field name="msgi" descr="" subnode="msgi_ext" capability="0" offset="0x0.0" selected_by="MSGI" size="0x80" />
	<field name="mdir_reg" descr="" subnode="mdir_reg_ext" capability="0" offset="0x0.0" selected_by="MDIR" size="0x40" />
	<field name="mcam_reg" descr="" subnode="mcam_reg_ext" capability="0" offset="0x0.0" selected_by="MCAM" size="0x48" />
	<field name="meccc" descr="" subnode="meccc_ext" capability="0" offset="0x0.0" selected_by="MECCC" size="0x14" />
	<field name="MRFV" descr="" subnode="MRFV_ext" capability="0" offset="0x0.0" selected_by="MRFV" size="0x40" />
	<field name="mdsr_reg" descr="" subnode="mdsr_reg_ext" capability="0" offset="0x0.0" selected_by="MDSR" size="0x30" />
	<field name="mfsv_reg" descr="" subnode="mfsv_reg_ext" capability="0" offset="0x0.0" selected_by="MFSV" size="0x30" />
	<field name="mtcq_reg" descr="" subnode="mtcq_reg_ext" capability="0" offset="0x0.0" selected_by="MTCQ" size="0x70" />
	<field name="mqdik_reg" descr="" subnode="mqdik_reg_ext" capability="0" offset="0x0.0" selected_by="MQDIK" size="0x208" />
	<field name="mkdc_reg" descr="" subnode="mkdc_reg_ext" capability="0" offset="0x0.0" selected_by="MKDC" size="0x2c" />
	<field name="rtcap_reg" descr="" subnode="rtcap_reg_ext" capability="0" offset="0x0.0" selected_by="RTCAP" size="0x14" />
	<field name="rtcc_reg" descr="" subnode="rtcc_reg_ext" capability="0" offset="0x0.0" selected_by="RTCC" size="0x24" />
	<field name="rtdpc_reg" descr="" subnode="rtdpc_reg_ext" capability="0" offset="0x0.0" selected_by="RTDPC" size="0x8" />
	<field name="rtedc_reg" descr="" subnode="rtedc_reg_ext" capability="0" offset="0x0.0" selected_by="RTEDC" size="0x14" />
	<field name="rtpsl_reg" descr="" subnode="rtpsl_reg_ext" capability="0" offset="0x0.0" selected_by="RTPSL" size="0x100" />
	<field name="rtptys_reg" descr="" subnode="rtptys_reg_ext" capability="0" offset="0x0.0" selected_by="RTPTYS" size="0x24" />
	<field name="rtpaos_reg" descr="" subnode="rtpaos_reg_ext" capability="0" offset="0x0.0" selected_by="RTPAOS" size="0xc" />
	<field name="rtsfc_reg" descr="" subnode="rtsfc_reg_ext" capability="0" offset="0x0.0" selected_by="RTSFC" size="0x100" />
	<field name="rtptpr_reg" descr="" subnode="rtptpr_reg_ext" capability="0" offset="0x0.0" selected_by="RTPTPR" size="0xc" />
	<field name="rttspc_reg" descr="" subnode="rttspc_reg_ext" capability="0" offset="0x0.0" selected_by="RTTSPC" size="0x4" />
	<field name="rtltc_reg" descr="" subnode="rtltc_reg_ext" capability="0" offset="0x0.0" selected_by="RTLTC" size="0xc" />
	<field name="rtcde_reg" descr="" subnode="rtcde_reg_ext" capability="0" offset="0x0.0" selected_by="RTCDE" size="0x14" />
	<field name="rtfcr_reg" descr="" subnode="rtfcr_reg_ext" capability="0" offset="0x0.0" selected_by="RTFCR" size="0x8" />
	<field name="rtpplr_reg" descr="" subnode="rtpplr_reg_ext" capability="0" offset="0x0.0" selected_by="RTPPLR" size="0xc" />
	<field name="rtpprt_reg" descr="" subnode="rtpprt_reg_ext" capability="0" offset="0x0.0" selected_by="RTPPRT" size="0x34" />
	<field name="rtpptt_reg" descr="" subnode="rtpptt_reg_ext" capability="0" offset="0x0.0" selected_by="RTPPTT" size="0x1c" />
	<field name="rtpcnt_reg" descr="" subnode="rtpcnt_reg_ext" capability="0" offset="0x0.0" selected_by="RTPCNT" size="0x100" />
	<field name="rtdsm_reg" descr="" subnode="rtdsm_reg_ext" capability="0" offset="0x0.0" selected_by="RTDSM" size="0x18" />
</node>

<node name="access_reg_summary_selector_ext" descr="" attr_is_union="1" size="0x208" >
	<field name="access_reg_summary" descr="" subnode="access_reg_summary_ext" offset="0x0.0" size="0x208" union_selector="$(parent).ctrl.id" />
	<field name="ctrl" descr="" subnode="access_reg_summary_ctrl_ext" offset="0x0.0" size="0x4.0" />
</node>

<node name="date_time_layout_ext" descr="" size="0x8.0" >
	<field name="hours" descr="hour (UTC) - 2 packed BCD digits" access="RW" offset="0x0.8" size="0x0.8" />
	<field name="minutes" descr="minutes - 2 packed BCD digits" access="RW" offset="0x0.16" size="0x0.8" />
	<field name="seconds" descr="seconds - 2 packed BCD digits" access="RW" offset="0x0.24" size="0x0.8" />
	<field name="day" descr="day - 2 packed BCD digits" access="RW" offset="0x4.0" size="0x0.8" />
	<field name="month" descr="month - 2 packed BCD digits" access="RW" offset="0x4.8" size="0x0.8" />
	<field name="year" descr="year - 4 packed BCD digits" access="RW" offset="0x4.16" size="0x0.16" />
</node>

<node name="enum_entry" descr="" size="0x4.0" >
</node>

<node name="histogram_couters_ext" descr="" size="0xa8.0" >
	<field name="hist" descr="value of FEC histogram [i]" subnode="uint64" access="RO" high_bound="20" low_bound="0" offset="0x0.0" size="0xa8.0" />
</node>

<node name="l1_general_counters_data_high_ext" descr="" size="0x80.0" >
	<field name="l1_entry_lane4_high" descr="" access="RO" offset="0x0.0" size="0x4.0" />
	<field name="l1_entry_lane4_low" descr="" access="RO" offset="0x4.0" size="0x4.0" />
	<field name="l1_entry_lane5_high" descr="" access="RO" offset="0x8.0" size="0x4.0" />
	<field name="l1_entry_lane5_low" descr="" access="RO" offset="0xC.0" size="0x4.0" />
	<field name="l1_entry_lane6_high" descr="" access="RO" offset="0x10.0" size="0x4.0" />
	<field name="l1_entry_lane6_low" descr="" access="RO" offset="0x14.0" size="0x4.0" />
	<field name="l1_entry_lane7_high" descr="" access="RO" offset="0x18.0" size="0x4.0" />
	<field name="l1_entry_lane7_low" descr="" access="RO" offset="0x1C.0" size="0x4.0" />
	<field name="l1_exit_lane4_high" descr="" access="RO" offset="0x20.0" size="0x4.0" />
	<field name="l1_exit_lane4_low" descr="" access="RO" offset="0x24.0" size="0x4.0" />
	<field name="l1_exit_lane5_high" descr="" access="RO" offset="0x28.0" size="0x4.0" />
	<field name="l1_exit_lane5_low" descr="" access="RO" offset="0x2C.0" size="0x4.0" />
	<field name="l1_exit_lane6_high" descr="" access="RO" offset="0x30.0" size="0x4.0" />
	<field name="l1_exit_lane6_low" descr="" access="RO" offset="0x34.0" size="0x4.0" />
	<field name="l1_exit_lane7_high" descr="" access="RO" offset="0x38.0" size="0x4.0" />
	<field name="l1_exit_lane7_low" descr="" access="RO" offset="0x3C.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane4_high" descr="" access="RO" offset="0x40.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane4_low" descr="" access="RO" offset="0x44.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane5_high" descr="" access="RO" offset="0x48.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane5_low" descr="" access="RO" offset="0x4C.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane6_high" descr="" access="RO" offset="0x50.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane6_low" descr="" access="RO" offset="0x54.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane7_high" descr="" access="RO" offset="0x58.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane7_low" descr="" access="RO" offset="0x5C.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane4_high" descr="" access="RO" offset="0x60.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane4_low" descr="" access="RO" offset="0x64.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane5_high" descr="" access="RO" offset="0x68.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane5_low" descr="" access="RO" offset="0x6C.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane6_high" descr="" access="RO" offset="0x70.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane6_low" descr="" access="RO" offset="0x74.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane7_high" descr="" access="RO" offset="0x78.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane7_low" descr="" access="RO" offset="0x7C.0" size="0x4.0" />
</node>

<node name="l1_general_counters_data_low_ext" descr="" size="0x80.0" >
	<field name="l1_entry_lane0_high" descr="" access="RO" offset="0x0.0" size="0x4.0" />
	<field name="l1_entry_lane0_low" descr="" access="RO" offset="0x4.0" size="0x4.0" />
	<field name="l1_entry_lane1_high" descr="" access="RO" offset="0x8.0" size="0x4.0" />
	<field name="l1_entry_lane1_low" descr="" access="RO" offset="0xC.0" size="0x4.0" />
	<field name="l1_entry_lane2_high" descr="" access="RO" offset="0x10.0" size="0x4.0" />
	<field name="l1_entry_lane2_low" descr="" access="RO" offset="0x14.0" size="0x4.0" />
	<field name="l1_entry_lane3_high" descr="" access="RO" offset="0x18.0" size="0x4.0" />
	<field name="l1_entry_lane3_low" descr="" access="RO" offset="0x1C.0" size="0x4.0" />
	<field name="l1_exit_lane0_high" descr="" access="RO" offset="0x20.0" size="0x4.0" />
	<field name="l1_exit_lane0_low" descr="" access="RO" offset="0x24.0" size="0x4.0" />
	<field name="l1_exit_lane1_high" descr="" access="RO" offset="0x28.0" size="0x4.0" />
	<field name="l1_exit_lane1_low" descr="" access="RO" offset="0x2C.0" size="0x4.0" />
	<field name="l1_exit_lane2_high" descr="" access="RO" offset="0x30.0" size="0x4.0" />
	<field name="l1_exit_lane2_low" descr="" access="RO" offset="0x34.0" size="0x4.0" />
	<field name="l1_exit_lane3_high" descr="" access="RO" offset="0x38.0" size="0x4.0" />
	<field name="l1_exit_lane3_low" descr="" access="RO" offset="0x3C.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane0_high" descr="" access="RO" offset="0x40.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane0_low" descr="" access="RO" offset="0x44.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane1_high" descr="" access="RO" offset="0x48.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane1_low" descr="" access="RO" offset="0x4C.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane2_high" descr="" access="RO" offset="0x50.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane2_low" descr="" access="RO" offset="0x54.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane3_high" descr="" access="RO" offset="0x58.0" size="0x4.0" />
	<field name="l1_1024ns_sleeping_lane3_low" descr="" access="RO" offset="0x5C.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane0_high" descr="" access="RO" offset="0x60.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane0_low" descr="" access="RO" offset="0x64.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane1_high" descr="" access="RO" offset="0x68.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane1_low" descr="" access="RO" offset="0x6C.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane2_high" descr="" access="RO" offset="0x70.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane2_low" descr="" access="RO" offset="0x74.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane3_high" descr="" access="RO" offset="0x78.0" size="0x4.0" />
	<field name="l1_1024ns_wake_lane3_low" descr="" access="RO" offset="0x7C.0" size="0x4.0" />
</node>

<node name="mcam_reg_ext" descr="" size="0x48.0" >
	<field name="access_reg_group" descr="Access Register ID groups \;0: First_128_REG_ID - Register IDs 0x9001 - 0x907F)\;1: Register_IDs_0x9080 - 0x90FF (bit 0 in mng_access_reg_cap_mask represent register ID 0x9080 while bit 127 represents register ID 0x90FF).\;2: Register_IDs_0x9100 - 0x917F (bit 0 in mng_access_reg_cap_mask represent register ID 0x9100 while bit 127 represents register ID 0x917F)." access="INDEX" enum="First_128_REG_ID=0x0,Register_IDs_0x9080=0x1,Register_IDs_0x9100=0x2" offset="0x0.0" size="0x0.8" />
	<field name="feature_group" descr="Feature list mask index: \;0: enhanced_features" access="INDEX" enum="enhanced_features=0x0" offset="0x0.16" size="0x0.8" />
	<field name="mng_access_reg_cap_mask" descr="Supported management&apos;s access register bitmask. Based on access_reg_group index. \;When bit is set, the register is supported in the device. \;For example:\;Bit 1: MFCR_0x9001\;Bit 2: MFSC_0x9002\;Bit 3: MFSM_0x9003\;Bit 4: MFSL_0x9004\;Bit 58: MGCR_0x903A\;Bit 73: MPPF_0x9049\;Bit 127: MCAP_0x907F" access="RO" enum="MFCR_0x9001=0x2,MFSC_0x9002=0x4,MFSM_0x9003=0x8,MFSL_0x9004=0x10,MGCR_0x903A=0x4000000,MPPF_0x9049=0x200,MCAP_0x907F=0x80000000" high_bound="3" low_bound="0" offset="0x8.0" size="0x10.0" />
	<field name="mng_feature_cap_mask" descr="Supported port&apos;s enhanced features.Based on feature_group index.\;When bit is set, The feature is supported in the device: \;Bit 0: MPCNT counter group- PCIE performance counters supported\;Bit 1: mtpps_fs - If set, field_select field in MTPPS register is supported.\;Bit 2: mtpps_enhanced_out_periodic_adjustment - If set, enhanced_out_periodic_adjustment field in MTPPS register is supported.\;Bit 3: tx_lossy_overflow_oper - If set, tx_overflow_buffer_pkt counter in MPCNT register is supported.\;Bit 4: pcie_outbound_stalled - if set, outbound_stalled_reads, outbound_stalled_writes, outbound_stalled_reads_events and outbound_stalled_writes_events counters in MPCNT are supported.\;Bit 5: Management pass through is supported\;Bit 6: sensor_map - If set, sensor_map is supported in MTCAP register.\;Bit 7: if set, module_status bit 8 (Module Low Power) in MCION register is supported. \;Bit 8: beacon_capability_disable - If set, beacon feature, as appears in MLCR register, in not supported by the device. \;Bit 9: dynamic_tx_overflow - If set, tx_overflow_sense field is supported in MPEGC register. \;Bit 10: mark_tx_action_cqe is supported if set to &apos;1&apos;.\;Bit 11: mark_tx_action_cnp is supported if set to &apos;1&apos;.\;Bit 12: dev_info is supported in  register is set to &apos;1&apos;.\;Bit 13: sensor_count field is 12bit size in MTMP and MTBR\;Bit 14: cs_tokens_supported is supported \;Bit 15: debug_fw_tokens_supported\;Bit 16: long_keys is supported \;Bit 17: pwr_status and pci_power are supported in MPEIN\;Bit 18: If set, accessing through device_type and device_index is supported in MCC, MCQI and MCQS\;Bit 19: pcie_sync_for_fw_update_supported is set to &apos;1&apos;\;Bit 20: ptpCyc2Realtime_modify - If set, the cycle to realtime translation offload is supported\;Bit 21: If set to &apos;1&apos;, reset_state in MFRL is supported\;Bit 22: If set to &apos;1&apos;, link_peer_max_speed is supported in MPEIN Register\;Bit 23: If set to &apos;1&apos;, slot_index field is supported in: MCIA, MCAS, MCION, MQSP, MTCAP, MTECR, MTMP, MTEWE, MTBR, MVCAP, MVCR, MGPIR, MDDT, MDCR.\;Bit 24: If set, transceiver burn flow is supported in MCC, MCQI and MCQS.\;Bit 26: If set, progress field is supported in MCQS\;Bit 28: If set, number_of_slots field is supported in MGPIR.\;Bit 29: If set, virtual hot plug / unplug is supported in MPEGC.\;Bit 30: If set, my_pf_number is supported in MPPF.\;Bit 31: If set, sdee is supported in MTMP\;Bit 34: If set, MCIA supports 32 D-words. Otherwise, 12 D-words.\;Bit 35: If set, MGIR.hw_info.technology is supported. \;Bit 37: If set, lp_msb is supported for MLCR, MPIR Bit 39: If set, MRCS and RMDT tokens are supported in MCQS\;Bit 40: If set, &apos;encryption&apos; field in MGIR is supported\;Bit 43: If set, MFCR supports tacho_active_msb field\;Bit 44: If set, FORE supports fan_under_limit_msb and fan_over_limit_msb fields\;Bit 45: If set, MFRL.pci_rescan_required is supported\;Bit 46: time_adjust_range_extended - if set, the MTUTC.time_adjustment range is extended to -200,000 to +200,000\;Bit 47: If set, MTUTC.freq_adj_units=1 is supported\;Bit 48: If set, MRSR.command=6 is supported\;Bit 49: If set, MCQS.identifier support CRCS and CRDT tokens\;Bit 51: If set, MTUTC.freq_adj_units=2 is supported\;\;Bit 53: If set, Mlx mlxfwreset with downstream port is supported by FW [Internal]: NIC only, FW rejects reset till user committed that traffic is disabled\;\;" access="RO" high_bound="3" low_bound="0" offset="0x28.0" size="0x10.0" />
</node>

<node name="mcc_reg_ext" descr="" size="0x20.0" >
	<field name="instruction" descr="Command to be executed by the FSM\;0x1: LOCK_UPDATE_HANDLE\;0x2: RELEASE_UPDATE_HANDLE \;0x3: UPDATE_COMPONENT\;0x4: VERIFY_COMPONENT\;0x6: ACTIVATE\;0x7: READ_COMPONENT\;0x8: CANCEL\;0x9: CHECK_UPDATE_HANDLE\;0xA: FORCE_HANDLE_RELEASE\;0xB: READ_PENDING_COMPONENT\;0xC: DOWNSRTEAM_DEVICE_TRANSFER\;Other values are reserved. Applicable for write operation only." access="RW" enum="LOCK_UPDATE_HANDLE=0x1,RELEASE_UPDATE_HANDLE=0x2,UPDATE_COMPONENT=0x3,VERIFY_COMPONENT=0x4,ACTIVATE=0x6,READ_COMPONENT=0x7,CANCEL=0x8,CHECK_UPDATE_HANDLE=0x9,FORCE_HANDLE_RELEASE=0xa,READ_PENDING_COMPONENT=0xb,DOWNSRTEAM_DEVICE_TRANSFER=0xc" offset="0x0.0" size="0x0.8" />
	<field name="activation_delay_sec" descr="This is a configuration that delays the activation of the component in seconds. Relevant only for activate command.\;This configuration is volatile." access="RW" offset="0x0.8" size="0x0.8" />
	<field name="time_elapsed_since_last_cmd" descr="The number of seconds elapsed since the update_handle owner last issued a command. The time saturates at 0xFFF." access="RO" offset="0x0.16" size="0x0.12" />
	<field name="component_index" descr="Index of the accessed component. \;Value from MCQS.component_index\;Valid for \;UPDATE_COMPONENT, ACTIVATE_COMPONENET, READ_COMPONENT and READ_PENDING_COMPONENT instructions. Otherwise, this field is reserved." access="INDEX" offset="0x4.0" size="0x0.16" />
	<field name="update_handle" descr="Token representing the current flow executed by the FSM." access="RW" offset="0x8.0" size="0x0.24" />
	<field name="auto_update" descr="Auto-update to all matching downstream devices is requested." access="WO" offset="0x8.31" size="0x0.1" />
	<field name="control_state" descr="Current Update FSM state\;0x0: IDLE\;0x1: LOCKED\;0x2: INITIALIZE\;0x3: DOWNLOAD\;0x4: VERIFY\;0x5: APPLY\;0x6: ACTIVATE\;0x7: UPLOAD\;0x8: UPLOAD_PENDING\;0x9: DOWNSRTEAM_DEVICE_TRANSFER\;Other values are reserved" access="RO" enum="IDLE=0x0,LOCKED=0x1,INITIALIZE=0x2,DOWNLOAD=0x3,VERIFY=0x4,APPLY=0x5,ACTIVATE=0x6,UPLOAD=0x7,UPLOAD_PENDING=0x8,DOWNSRTEAM_DEVICE_TRANSFER=0x9" offset="0xC.0" size="0x0.4" />
	<field name="error_code" descr="Indicates the successful completion of the instruction, or the reason it failed. \;0x0: OK\;0x1: ERROR\;0x2: REJECTED_DIGEST_ERR\;0x3: REJECTED_NOT_APPLICABLE\;0x4: REJECTED_UNKNOWN_KEY\;0x5: REJECTED_AUTH_FAILED\;0x6: REJECTED_UNSIGNED\;0x7: REJECTED_KEY_NOT_APPLICABLE\;0x8: REJECTED_BAD_FORMAT\;0x9: BLOCKED_PENDING_RESET\;0xA: REJECTED_NOT_A_SECURED_FW\;0xB: REJECTED_MFG_BASE_MAC_NOT_LISTED\;0xC: REJECTED_NO_DEBUG_TOKEN\;0xD: REJECTED_VERSION_NUM_MISMATCH\;0xE: REJECTED_USER_TIMESTAMP_MISMATCH\;0xF: REJECTED_FORBIDDEN_VERSION\;0x10: FLASH_ERASE_ERROR\;0x11: REJECTED_REBURN_RUNNING_AND_RETRY\;0x12: REJECTED_LINKX_TYPE_NOT_SUPPORTED\;0x13: REJECTED_HOST_STORAGE_IN_USE\;0x14: REJECTED_LINKX_TRANSFER (see module index in rejected_device_index)\;0x15: REJECTED_LINKX_ACTIVATE (see module index in rejected_device_index)\;0x16: REJECTED_INCOMPATIBLE_FLASH\;0x17: REJECTED_TOKEN_ALREADY_APPLIED\;0x18: REJECTED_FW_BURN_DRAM_NOT_AVAILABLE\;0x19: FW_BURN_REJECTED_INVALID_SECURITY_VERSION\;0x1A: FW_BURN_REJECTED_CERT_CER509 \;0x1B: FW_BURN_REJECTED_CERT_SIGNATURE\;0x1C: FW_BURN_REJECTED_CERT_METADATA\;0x1D: FW_BURN_REJECTED_CERT_INTERNAL_ERROR_0 \;0x1E: FW_BURN_REJECTED_CERT_NO_PLACE\;0x1F: FW_BURN_REJECTED_CERT_REMOVAL_NO_MATCH_CERT_UIDD\;0x20: FW_BURN_REJECTED_CERTI_INTERNAL_ERROR_1 \;0x21: FW_BURN_REJECTED_CERT_INTERNAL_ERROR_2 0x22: FW_BURN_REJECTED_CERT_OF_NUM_OF_SWAP\;0x23: FW_BURN_REJECTED_CERT_INTERNAL_ERROR_3 \;0x24: FW_BURN_REJECTED_CERT_INTERNAL_ERROR_4 \;0x25: FW_BURN_REJECTED_CERT_NOT_ALLOWED_SAME_CERT_UIDD \;0x26: FW_BURN_REJECTED_CERTIFICATE_INTERNAL_ERROR_5 \;0x27: FW_BURN_REJECTED_CERTIFICATE_INTERNAL_ERROR_6 \;0x28: REJECTED_FLASH_WP\;\;Other values should be treated as an unknown error." access="RO" offset="0xC.8" size="0x0.8" />
	<field name="control_progress" descr="Indicates the estimated progress status of the current operation executed by the FSM. Valid values are 0..100.\;101 indicates that progress reporting is not supported for this update state." access="RO" offset="0xC.16" size="0x0.7" />
	<field name="handle_owner_host_id" descr="For handle_owner_type BMC, command-interface and ICMD, indicates the identifier of the host of the handle owner.\;Otherwise reserved" access="RO" offset="0xC.24" size="0x0.4" />
	<field name="handle_owner_type" descr="Type of entity holding the update handle:\;0x0: unspecified\;0x1: Chassis BMC\;0x2: MAD\;0x3: BMC\;0x4: command interface\;0x5: ICMD \;Other values are reserved." access="RO" offset="0xC.28" size="0x0.4" />
	<field name="component_size" descr="Component size in bytes. \;Valid for UPDATE_COMPONENT instruction. Specifying the size may shorten the update time.\;Value 0x0 means that size is unspecified." access="WO" offset="0x10.0" size="0x4.0" />
	<field name="device_type" descr="Peripheral device type:\;0: Switch_or_NIC\;1: Gearbox" access="INDEX" enum="Switch_or_NIC=0x0,Gearbox=0x1" offset="0x14.0" size="0x0.8" />
	<field name="device_index" descr="Device number.\;For gearboxes, the index represents the gearbox die. \;For cables, the index represents the module index starting at index 1. Index 0 indicates the host device." access="INDEX" offset="0x14.16" size="0x0.12" />
	<field name="device_index_size" descr="In multiple downstream devices action, the action will be executed starting on device_index and ending on device_index + device_index_size - 1." access="RW" offset="0x18.0" size="0x0.12" />
	<field name="rejected_device_index" descr="The device index that the action has been rejected to." access="RO" offset="0x18.16" size="0x0.12" />
</node>

<node name="mcda_reg_ext" descr="" size="0x90.0" >
	<field name="update_handle" descr="Update handle registered when the FSM was activated." access="RW" offset="0x0.0" size="0x0.24" />
	<field name="offset" descr="Offset of accessed address relative to component start. Accesses must be in accordance to log_mcda_word_size in Table 212, &quot;MCQI CAPABILITIES Info Layout,&quot; on page 216" access="RW" offset="0x4.0" size="0x4.0" />
	<field name="size" descr="Size of the data accessed, given in bytes" access="RW" offset="0x8.0" size="0x0.16" />
	<field name="data" descr="Data block accessed" access="RW" high_bound="31" low_bound="0" offset="0x10.0" size="0x80.0" />
</node>

<node name="mcqi_activation_method_ext" descr="" size="0x7c.0" >
	<field name="all_hosts_sync" descr="When set, the operation needed to move the component form ACTIVE_PENDING_RESET to ACTIVE should happen simultaneously on all hosts." access="RO" offset="0x0.0" size="0x0.1" />
	<field name="auto_activate" descr="This component will be ACTIVE or ACTIVE_PENDING_RESET after the APPLY state." access="RO" offset="0x0.1" size="0x0.1" />
	<field name="pending_fw_reset" descr="This component goes to ACTIVE_PENDING_RESET after activation.\;A FW reset will move it to ACTIVE state." access="RO" offset="0x0.2" size="0x0.1" />
	<field name="pending_server_reboot" descr="This component goes to ACTIVE_PENDING_RESET state after activation.\;A server reset (PCIe PERST#), will move it ACTIVE state." access="RO" offset="0x0.3" size="0x0.1" />
	<field name="pending_server_dc_power_cycle" descr="This component goes to ACTIVE_PENDING_RESET state after activation.\;DC power cycle (power cycle of PCI power rails), will move it ACTIVE state." access="RO" offset="0x0.4" size="0x0.1" />
	<field name="pending_server_ac_power_cycle" descr="This component goes to ACTIVE_PENDING_RESET state after activation.\;AC power cycle (power cycle for both PCI power rails and AUX power), will move it ACTIVE state." access="RO" offset="0x0.5" size="0x0.1" />
	<field name="self_activation" descr="When set, the component supports self activation. For cables, please refer to activation_type in LINKX_PROPERTIES data for more details." access="RO" offset="0x0.6" size="0x0.1" />
</node>

<node name="mcqi_cap_ext" descr="" size="0x7c.0" >
	<field name="supported_info_bitmask" descr="Bitmask indicating which info_type(s) are supported for this component. Set bit indicates the property set is supported\;bit 1: VERSION\;bit 5: ACTIVATION_METHOD\;Other bits are reserved. CAPABILITIES set is always supported.\;bit 6: LinkX\;bit 7: Clock Synchronizer" access="RO" offset="0x0.0" size="0x4.0" />
	<field name="component_size" descr="The size of the component given in bytes. Value 0x0 indicates that the size in unknown.\;For some components, size may only be available in the READ_COMPONENT state." access="RO" offset="0x4.0" size="0x4.0" />
	<field name="max_component_size" descr="Maximum size for this component, given in bytes." access="RO" offset="0x8.0" size="0x4.0" />
	<field name="mcda_max_write_size" descr="Maximal write size for MCDA" access="RO" offset="0xC.0" size="0x0.16" />
	<field name="log_mcda_word_size" descr="Log 2 of the access word size in bytes.\;Read and write access must be aligned to the word size. Write access must be done for an integer number of words." access="RO" offset="0xC.28" size="0x0.4" />
	<field name="match_base_guid_mac" descr="The device only accepts updates for this component that explicitly lists its base MAC and/or base GUID" access="RW" offset="0x10.26" size="0x0.1" />
	<field name="check_user_timestamp" descr="A user defined timestamp (MVTS) is active for this component." access="RW" offset="0x10.27" size="0x0.1" />
	<field name="match_psid" descr="PSID is validated for this component update." access="RW" offset="0x10.28" size="0x0.1" />
	<field name="match_chip_id" descr="Chip ID (device_hw_revision) is validated for this component update." access="RW" offset="0x10.29" size="0x0.1" />
	<field name="signed_updates_only" descr="Only signed components are accepted." access="RW" offset="0x10.30" size="0x0.1" />
	<field name="rd_en" descr="When set, this components may be read" access="RO" offset="0x10.31" size="0x0.1" />
</node>

<node name="mcqi_clock_source_properties_ext" descr="" size="0x4.0" >
	<field name="image_version_minor" descr="Image Version Minor Number" access="RO" offset="0x0.0" size="0x0.4" />
	<field name="image_version_major" descr="Image Version Major Number" access="RO" offset="0x0.4" size="0x0.4" />
	<field name="vendor_id" descr="Clock Source Device Vendor Id\;0: Renesas\;1: SiTime 148\;2: SiTime 348\;3: TI\;4-255: Reserved" access="RO" offset="0x0.16" size="0x0.8" />
</node>

<node name="mcqi_linkx_properties_ext" descr="" size="0x7c.0" >
	<field name="fw_image_status_bitmap" descr="Bit 0: Image A is running\;Bit 1: Image A is committed, module boots from image A\;Bit 2: Image A is erased / empty\;Bit 3: Reserved\;Bit 4: Image B is running\;Bit 5: Image B is committed, module boots from image B\;Bit 6: Image B is erased / empty\;Bit 7: Reserved" access="RO" offset="0x0.0" size="0x0.8" />
	<field name="fw_image_info_bitmap" descr="Bit 0: FW image A is present \;Bit 1: FW image B is present\;Bit 2: Factory / boot image is present\;Bits 3-7: Reserved" access="RO" offset="0x0.16" size="0x0.8" />
	<field name="image_a_minor" descr="Image A FW minor version" access="RO" offset="0x4.0" size="0x0.8" />
	<field name="image_a_major" descr="Image A FW major version" access="RO" offset="0x4.8" size="0x0.8" />
	<field name="image_a_subminor" descr="Image A FW subminor number" access="RO" offset="0x8.0" size="0x0.16" />
	<field name="image_b_minor" descr="Image B FW minor version" access="RO" offset="0xC.0" size="0x0.8" />
	<field name="image_b_major" descr="Image B FW major version" access="RO" offset="0xC.8" size="0x0.8" />
	<field name="image_b_subminor" descr="Image B FW subminor number" access="RO" offset="0x10.0" size="0x0.16" />
	<field name="factory_image_minor" descr="Factory / boot image FW minor version" access="RO" offset="0x14.0" size="0x0.8" />
	<field name="factory_image_major" descr="Factory / boot image FW major version" access="RO" offset="0x14.8" size="0x0.8" />
	<field name="factory_image_subminor" descr="Factory / boot image FW subminor number" access="RO" offset="0x18.0" size="0x0.16" />
	<field name="management_interface_protocol" descr="0: Does not support either one of the FW update procedures defined below\;1: SFF-8636 management interface and pseudo-CMIS FW. Update is supported\;2: CMIS 4.0 is implemented" access="RO" offset="0x1C.0" size="0x0.6" />
	<field name="activation_type" descr="0: HW reset is required. Host should be prepared to power cycle a cable after sending a RunFWImage command.\;1: Self-activation with HW reset contained in the RunFWImage command. No additional actions required from the host.\;2:Self-activation with hitless reset contained in the RunFWImage command. No additional actions required from the host.\;3-15: Reserved" access="RO" offset="0x1C.10" size="0x0.4" />
	<field name="vendor_sn" descr="Vendor Serial Number" access="RO" offset="0x20.0" size="0x0.16" />
</node>

<node name="mcqi_reg_data_auto_ext" descr="" attr_is_union="1" size="0x7c.0" >
	<field name="mcqi_cap_ext" descr="" subnode="mcqi_cap_ext" offset="0x0.0" selected_by="CAPABILITIES" size="0x7c.0" />
	<field name="mcqi_version_ext" descr="" subnode="mcqi_version_ext" offset="0x0.0" selected_by="VERSION" size="0x7c.0" />
	<field name="mcqi_activation_method_ext" descr="" subnode="mcqi_activation_method_ext" offset="0x0.0" selected_by="ACTIVATION_METHOD" size="0x7c.0" />
	<field name="mcqi_linkx_properties_ext" descr="" subnode="mcqi_linkx_properties_ext" offset="0x0.0" selected_by="LINKX_PROPERTIES" size="0x7c.0" />
	<field name="mcqi_clock_source_properties_ext" descr="" subnode="mcqi_clock_source_properties_ext" offset="0x0.0" selected_by="CLOCK_SOURCE_PROPERTIES" size="0x4.0" />
</node>

<node name="mcqi_reg_ext" descr="" size="0x94.0" >
	<field name="component_index" descr="Component index gathered by &quot;MCQS - Management Component Query Status&quot;" access="INDEX" offset="0x0.0" size="0x0.16" />
	<field name="device_index" descr="Device number.\;For gearboxes, the index represents the gearbox die. \;For cables, the index represents the module index starting at index 1. Index 0 indicates the host device.\;\;For Clock Source EEPROM, the index represents the Clock Source Index, starting from 1" access="INDEX" offset="0x0.16" size="0x0.12" />
	<field name="read_pending_component" descr="When set, the register will return information about the pending component (if available)" access="INDEX" offset="0x0.31" size="0x0.1" />
	<field name="device_type" descr="Peripheral device type:\;0: Switch / NIC\;1: Gearbox" access="INDEX" offset="0x4.0" size="0x0.8" />
	<field name="info_type" descr="Component properties set.\;0x0: CAPABILITIES\;0x1: VERSION\;0x5: ACTIVATION_METHOD\;0x6: LINKX_PROPERTIES\;0x7: CLOCK_SOURCE_PROPERTIES\;Other values are reserved" access="RW" enum="CAPABILITIES=0x0,VERSION=0x1,ACTIVATION_METHOD=0x5,LINKX_PROPERTIES=0x6,CLOCK_SOURCE_PROPERTIES=0x7" offset="0x8.0" size="0x0.5" />
	<field name="info_size" descr="Properties set structure size, given in bytes." access="RO" offset="0xC.0" size="0x4.0" />
	<field name="offset" descr="The requested/returned data offset from the section start, given in bytes.\;Must be DWORD aligned.\;If offset is invalid, FW will return an error." access="RW" offset="0x10.0" size="0x4.0" />
	<field name="data_size" descr="The requested/returned data size, given in bytes.\;If data_size is not DWORD aligned, the last bytes are zero padded.\;If size is invalid, FW will return an error." access="RW" offset="0x14.0" size="0x0.16" />
	<field name="data" descr="Properties set structure according to info_type.\;CAPABILITIES - See Table 212, &quot;MCQI CAPABILITIES Info Layout,&quot; on page 216\;VERSION - See Table 214, &quot;MCQI VERSION Info Layout,&quot; on page 218\;ACTIVATION_METHOD - See Table 218, &quot;MCQI ACTIVATION_METHOD Info Layout,&quot; on page 220\;LINKX_PROPERTIES - See Table 220, &quot;MCQI LINKX_PROPERTIES Info Layout,&quot; on page 221\;CLOCK_SOURCE_PROPERTIES - See Table 222, &quot;MCQI CLOCK_SOURCE_PROPERTIES Layout,&quot; on page 223" subnode="mcqi_reg_data_auto_ext" access="RO" offset="0x18.0" size="0x7c.0" union_selector="$(parent).info_type" />
</node>

<node name="mcqi_version_ext" descr="" size="0x7c.0" >
	<field name="version_string_length" descr="" access="RW" offset="0x0.0" size="0x0.8" />
	<field name="user_defined_time_valid" descr="When set, the component has a valid user-defined version time-stamp in user_defined_time" access="RW" offset="0x0.28" size="0x0.1" />
	<field name="build_time_valid" descr="When set, the component has a valid creation time-stamp in build_time" access="RW" offset="0x0.29" size="0x0.1" />
	<field name="version" descr="Version number" access="RW" offset="0x4.0" size="0x4.0" />
	<field name="build_time" descr="Time of component creation. Valid only if build_time_valid is set. See Table 216, &quot;Date-Time Layout,&quot; on page 219" subnode="date_time_layout_ext" access="RW" offset="0x8.0" size="0x8.0" />
	<field name="user_defined_time" descr="User-defined time assigned to the component version. Valid only if user_defined_time_valid is set. See Table 216, &quot;Date-Time Layout,&quot; on page 219" subnode="date_time_layout_ext" access="RW" offset="0x10.0" size="0x8.0" />
	<field name="build_tool_version" descr="Build tool version number.\;Valid only when not equal to 0" access="RW" offset="0x18.0" size="0x4.0" />
	<field name="version_string" descr="NULL terminated string representing the version." access="RW" high_bound="91" low_bound="0" offset="0x20.24" size="0x5c.0" />
</node>

<node name="mcqs_reg_ext" descr="" size="0x10.0" >
	<field name="component_index" descr="Component Index. Values range from 1 to the last component indicated by last_index_flag." access="INDEX" offset="0x0.0" size="0x0.16" />
	<field name="device_index" descr="Device number.\;For gearboxes, the index represents the gearbox die. \;For cables, the index represents the module index starting at index 1. Index 0 indicates the host device.\;For Clock synchronizer, index is used to represent the clock sync&apos; device index. Starting from 1." access="INDEX" offset="0x0.16" size="0x0.12" />
	<field name="last_index_flag" descr="When set, this component is the last component (highest component_index)." access="RO" offset="0x0.31" size="0x0.1" />
	<field name="identifier" descr="This field uniquely identifies a specific component type. \;0x1: BOOT_IMG\;0x4: OEM_NVCONFIG\;0x5: MLNX_NVCONFIG\;0x6: CS_TOKEN\;0x7: DBG_TOKEN\;0xA: Gearbox\;0xB: CC_ALGO - Congestion Control Algorithm\;0xC: LINKX_IMG\;0xD: CRYPTO_TO_COMMISSIONING\;0xE: RMCS_TOKEN\;0xF: RMDT_TOKEN\;0x10: CRCS_TOKEN. \;0x11: CRDT_TOKEN. \;0x12: CLOCK_SYNC_EEPROM.  \;Other values are reserved" access="RO" enum="BOOT_IMG=0x1,OEM_NVCONFIG=0x4,MLNX_NVCONFIG=0x5,CS_TOKEN=0x6,DBG_TOKEN=0x7,Gearbox=0xa,CC_ALGO=0xb,LINKX_IMG=0xc,CRYPTO_TO_COMMISSIONING=0xd,RMCS_TOKEN=0xe,RMDT_TOKEN=0xf,CRCS_TOKEN_=0x10,CRDT_TOKEN_=0x11,CLOCK_SYNC_EEPROM_=0x12" offset="0x4.0" size="0x0.16" />
	<field name="component_update_state" descr="Component state in update flow\;0x0: IDLE\;0x1: IN_PROGRESS\;0x2: APPLIED\;0x3: ACTIVE \;0x4: ACTIVE_PENDING_RESET\;0x5: FAILED\;0x6: CANCELED\;0x7: BUSY\;\;Other values are reserved" access="RO" enum="IDLE=0x0,IN_PROGRESS=0x1,APPLIED=0x2,ACTIVE=0x3,ACTIVE_PENDING_RESET=0x4,FAILED=0x5,CANCELED=0x6,BUSY=0x7" offset="0x8.0" size="0x0.4" />
	<field name="component_status" descr="The status of the component:\;0x0: NOT_PRESENT - The component is supported by the device but, currently not present\;0x1: PRESENT - This component is present. For downstream devices link LinkX component, this is an indication that the binary image is present at the host device memory.\;0x2: IN_USE - The component is present and currently in use." access="RO" enum="NOT_PRESENT=0x0,PRESENT=0x1,IN_USE=0x2" offset="0x8.4" size="0x0.5" />
	<field name="progress" descr="Progress in percentage (from 0 to 100). This field is only relevant for cables." access="RO" offset="0x8.9" size="0x0.7" />
	<field name="device_type" descr="Peripheral device type:\;0: Switch_or_NIC\;1: Gearbox" access="INDEX" offset="0xC.0" size="0x0.8" />
	<field name="last_update_state_changer_host_id" descr="For last_update_state_changer_type BMC, command-interface and ICMD, indicates the identifier of the host of the handle owner. Otherwise reserved." access="RO" offset="0xC.24" size="0x0.4" />
	<field name="last_update_state_changer_type" descr="Indicates which entity was the last to change the component_update_state of this component.\;0x0: unspecified\;0x1: Chassis_BMC\;0x2: MAD\;0x3: BMC\;0x4: command_interface\;0x5: ICMD\;\;Other values are reserved" access="RO" enum="unspecified=0x0,Chassis_BMC=0x1,MAD=0x2,BMC=0x3,command_interface=0x4,ICMD=0x5" offset="0xC.28" size="0x0.4" />
</node>

<node name="mdir_reg_ext" descr="" size="0x40.0" >
	<field name="device_id" descr="Device ID" access="RO" high_bound="7" low_bound="0" offset="0x0.0" size="0x20.0" />
</node>

<node name="mdsr_reg_ext" descr="" size="0x30.0" >
	<field name="status" descr="0: The debug session ended successfully\;1: Failed to execute the operation. See additional_info for more details.\;2: Debug session active. See type_of_token for more details.\;3: No token applied\;4: Challenge provided, no token installed yet, see type_of_token for details.\;5: Timeout before token installed, see type_of_token for details\;6: Timeout of active token.\;7-15: Reserved\;\;Note: Status might be &apos;0&apos; even when debug query is not allowed and additional_info field will expose the reason." access="RO" offset="0x0.0" size="0x0.4" />
	<field name="additional_info" descr="0: No additional information available \;1: There is no debug session in progress\;2: FW is not secured, debug session cannot be ended\;3: Fail - Debug end request cannot be accepted. \;4: Fail - Host is not allowed to query debug session\;5: Debug session active" access="RO" offset="0x0.8" size="0x0.6" />
	<field name="type_of_token" descr="0: CS token \;1: Debug FW token \;2: FRC token \;3: RMCS token\;4: RMDT token \;5: CRCS token \;6: CRDT token" access="INDEX" offset="0x0.24" size="0x0.8" />
	<field name="end" descr="Set to &apos;1&apos; to end debug session.\;Setting to &apos;0&apos; will not trigger any operation." access="WO" offset="0x4.31" size="0x0.1" />
	<field name="time_left" descr="Time left in seconds.\;In case that status is 2 (debug session active) - time left for token operation\;In case that status is 4 (challenge provided, no token installed yet) - time left for token installation\;For any other status, field should be zero" access="RO" offset="0x8.0" size="0x4.0" />
</node>

<node name="meccc_ext" descr="" size="0x14.0" >
	<field name="slot_index" descr="Slot index\;0: Main board" access="INDEX" offset="0x0.0" size="0x0.4" />
	<field name="device_index" descr="Device index\;For gearboxes, the index represents the gearbox die" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="clr" descr="Clear counters\;" access="OP" offset="0x4.0" size="0x0.1" />
	<field name="ecc_crt_cnt" descr="ECC Correctable Counter\;Counter increments 1 time per each SRAM (including TCAM) which had 1 or more ECC correctable events. \;Cleared at: (1) reset (including soft_reset), (2) clear bit\;Counts from: (1) main, (2) all tiles" access="RO" offset="0xC.0" size="0x4.0" />
	<field name="ecc_ucrt_cnt" descr="ECC Uncorrectable Counter\;Cleared at: (1) reset (including soft_reset), (2) clear bit\;" access="RO" offset="0x10.0" size="0x0.8" />
</node>

<node name="mfsv_reg_ext" descr="" size="0x30.0" >
	<field name="efuses_prog_en" descr="When this bit is set, it indicates that it is allowed for the boot FW to program the FW security version related EFUSEs if needed. This bit is not relevant in case the FW operates in an automatically EFUSEs programming approach (set in the INI file). Once set to 1, this configuration will be relevant only for the upcoming boot, thus this configuration will be set back to 0 upon next boot. In addition, once this bit was set to 1 there is no option to clear it. option to clear it. In addition, once this bit was set to 1, there is no option to clear it." access="RW" offset="0x0.0" size="0x0.1" />
	<field name="fw_sec_ver_stat" descr="Firmware security version status.0: EFUSEs value is equal to the currently running FW image value. No change is needed.1: EFUSEs value is smaller than the currently running FW image value. An update to the EFUSEs is required.2-3: Reserved" access="RO" offset="0x0.1" size="0x0.2" />
	<field name="efuses_prog_method" descr="EFUSEs programming method.0: manually. Upon boot, if FW indicates that FW_sec_ver_stat is 1 and only if EFUSEs_prog_en is 1, it will program the EFUSEs as needed.1: automatically. Upon boot, if FW indicates that FW_sec_ver_stat is 1, it will program the EFUSEs as needed." access="RO" offset="0x0.3" size="0x0.1" />
	<field name="img_sec_ver" descr="Image security version value" access="RO" offset="0x4.0" size="0x4.0" />
	<field name="efuses_sec_ver" descr="EFUSEs security version value" access="RO" offset="0x8.0" size="0x4.0" />
</node>

<node name="mgcr_reg_ext" descr="" size="0x20.0" >
	<field name="segment" descr="The GPIO segment which the command&apos;s parameters apply" access="RW" offset="0x0.0" size="0x0.8" />
	<field name="segments_count" descr="Ceiling function of total number of GPIOs / 32 in the system." access="RO" offset="0x0.8" size="0x0.8" />
	<field name="GPIO_data_in" descr="Input value of accessible GPIO[i] signals.\;When GPIO_access_en[i] = 0, GPIO_data_in[i] always returns 0" access="RO" offset="0x4.0" size="0x4.0" />
	<field name="GPIO_data_out" descr="Output value of accessible GPIO signals.\;When GPIO_access_en[i] = 0, GPIO_data_out[i] always returns 0" access="RO" offset="0x8.0" size="0x4.0" />
	<field name="GPIO_set" descr="These 2 fields are used together to control GPIO signals in the following manner:\;GPIO_set[i]=0, GPIO_clear[i]=0 : GPIO_data_out[i] = No Change\;GPIO_set[i]=0, GPIO_clear[i]=1 : GPIO_data_out[i] = 0\;GPIO_set[i]=1, GPIO_clear[i]=0 : GPIO_data_out[i] = 1\;GPIO_set[i]=1, GPIO_clear[i]=1 : GPIO_data_out[i] = not(GPIO_data_out[i])\;Ignored for non-controllable GPIO signals." access="WO" offset="0xC.0" size="0x4.0" />
	<field name="GPIO_clear" descr="These 2 fields are used together to control GPIO signals in the following manner:\;GPIO_set[i]=0, GPIO_clear[i]=0 : GPIO_data_out[i] = No Change\;GPIO_set[i]=0, GPIO_clear[i]=1 : GPIO_data_out[i] = 0\;GPIO_set[i]=1, GPIO_clear[i]=0 : GPIO_data_out[i] = 1\;GPIO_set[i]=1, GPIO_clear[i]=1 : GPIO_data_out[i] = not(GPIO_data_out[i])\;Ignored for non-controllable GPIO signals." access="WO" offset="0x10.0" size="0x4.0" />
	<field name="GPIO_access_en" descr="Access allowance to the corresponding GPIO signal.\;0: GPIO[i] is not observable / controllable by the host SW.\;1: GPIO[i] is observable / controllable by the host SW." access="RO" offset="0x14.0" size="0x4.0" />
	<field name="direction" descr="0: GPIO[i] is an input only signal\;1: GPIO[i] is an output signal. Data out can be updates by the host SW and data in can be queried by the host SW.\;For non-accessible GPIOs, the corresponding value is 0." access="RO" offset="0x18.0" size="0x4.0" />
	<field name="drive_type" descr="0: GPIO[i] is an open drain output. The device can only drive the GPIO[i] output pin low when GPIO_data_out[i] is 0. When GPIO_data_out[i] is 1, GPIO[i] is in HighZ. \;1: GPIO[i] is a full-drive output pin\;When GPIO_access_en[i] =0, direction[i] and drive_type[i] are always read as 0." access="RO" offset="0x1C.0" size="0x4.0" />
</node>

<node name="mgir_dev_info_ext" descr="" size="0x1c.0" >
	<field name="dev_branch_tag" descr="The format of the string represented by ASCII." access="RO" high_bound="27" low_bound="0" offset="0x0.24" size="0x1c.0" />
</node>

<node name="mgir_ext" descr="" size="0xa0.0" >
	<field name="hw_info" descr="Hardware Information, see Table 236, &quot;Hardware Info Layout,&quot; on page 234" subnode="mgir_hardware_info_ext" access="RW" offset="0x0.0" size="0x20.0" />
	<field name="fw_info" descr="Firmware Information, see Table 239, &quot;Firmware Info Layout,&quot; on page 237" subnode="mgir_fw_info_ext" access="RW" offset="0x20.0" size="0x40.0" />
	<field name="sw_info" descr="Software Information, see Table 241, &quot;Software Info Layout,&quot; on page 239\;This field indicates the oldest software version compatible with the current firmware" subnode="mgir_sw_info_ext" access="RW" offset="0x60.0" size="0x20.0" />
	<field name="dev_info" descr="Development Information, see Table 245, &quot;Development Info Layout,&quot; on page 243" subnode="mgir_dev_info_ext" access="RW" offset="0x80.0" size="0x1c.0" />
</node>

<node name="mgir_fw_info_ext" descr="" size="0x40.0" >
	<field name="sub_minor" descr="Sub-minor firmware version number.\;Deprecated and returns &apos;0&apos;. \;Refer to extended_sub_minor." access="RO" offset="0x0.0" size="0x0.8" />
	<field name="minor" descr="Minor firmware version number.\;Deprecated and returns &apos;0&apos;. \;Refer to extended_minor." access="RO" offset="0x0.8" size="0x0.8" />
	<field name="major" descr="Major firmware version number.\;Deprecated and returns &apos;0&apos;. \;Refer to extended_major." access="RO" offset="0x0.16" size="0x0.8" />
	<field name="secured" descr="When set, the device is running firmware with secure-firmware updates capabilities." access="RO" offset="0x0.24" size="0x0.1" />
	<field name="signed_fw" descr="When set the device is running a signed FW binaries." access="RO" offset="0x0.25" size="0x0.1" />
	<field name="debug" descr="When set, the device is running a debug firmware. &apos;debug&apos; binary can only be installed on specific devices (identified by their &apos;Factory base MAC&apos;), which currently run a specific firmware version. These restrictions are expressed by a signed &apos;debug&apos; token that must be loaded to the device before installing the debug binary." access="RO" offset="0x0.26" size="0x0.1" />
	<field name="dev" descr="*NOTE* this field has diff meaning for Switch vs. NIC \;\;\;\;\;Switch &amp; Retimer:\;The device is running:\;0: regular FW branch\;1: development branch" access="RO" offset="0x0.27" size="0x0.1" />
	<field name="string_tlv" descr="When set, string-TLV is supported.\;For Retimer - always return 0 (not supported)." access="RO" offset="0x0.28" size="0x0.1" />
	<field name="dev_sc" descr="*NOTE* for NICs same as dev field\;Development-secure:\;The device is running:\;0: a regular-secure firmware version\;1: a development-secure firmware version" access="RO" offset="0x0.30" size="0x0.1" />
	<field name="build_id" descr="Firmware Build ID. Optional. ." access="RO" offset="0x4.0" size="0x4.0" />
	<field name="year" descr="Firmware installation date. \;\;For example: 3 May 2004 will be coded as Month= 0x05, Day= 0x03, and Year= 0x04" access="RO" offset="0x8.0" size="0x0.16" />
	<field name="day" descr="Firmware installation date. \;\;For example: 3 May 2004 will be coded as Month= 0x05, Day= 0x03, and Year= 0x04" access="RO" offset="0x8.16" size="0x0.8" />
	<field name="month" descr="Firmware installation date. \;\;For example: 3 May 2004 will be coded as Month= 0x05, Day= 0x03, and Year= 0x04" access="RO" offset="0x8.24" size="0x0.8" />
	<field name="hour" descr="Firmware installation hour.\;For example 17:43 will be coded as 0x1743" access="RO" offset="0xC.0" size="0x0.16" />
	<field name="psid" descr="FW PSID" access="RO" high_bound="15" low_bound="0" offset="0x10.24" size="0x10.0" />
	<field name="ini_file_version" descr="User-configured version number of the current INI file." access="RO" offset="0x20.0" size="0x4.0" />
	<field name="extended_major" descr="FW version&apos;s Major field in extended (32b) format." access="RO" offset="0x24.0" size="0x4.0" />
	<field name="extended_minor" descr="FW version&apos;s Minor field in extended (32b) format." access="RO" offset="0x28.0" size="0x4.0" />
	<field name="extended_sub_minor" descr="FW version&apos;s SubMinor field in extended (32b) format." access="RO" offset="0x2C.0" size="0x4.0" />
	<field name="isfu_major" descr="incremented by one when version is not ISSUable" access="RO" offset="0x30.0" size="0x0.16" />
	<field name="disabled_tiles_bitmap" descr="Bitmap representing the disabled tiles in the ASIC. Tile &apos;0&apos; is represented by the msb bit. \;0: tile is enabled\;1: tile is disabled\;\;The total number of tiles can be derived through MGPIR register." access="RO" offset="0x30.16" size="0x0.16" />
	<field name="life_cycle" descr="0: Production\;1: GA Secured\;2: GA Non-Secured\;3: RMA" access="RO" offset="0x34.0" size="0x0.2" />
	<field name="sec_boot" descr="0: Disable\;1: Enable" access="RO" offset="0x34.2" size="0x0.1" />
	<field name="encryption" descr="0: Disable\;1: Enable" access="RO" offset="0x34.3" size="0x0.1" />
</node>

<node name="mgir_hardware_info_ext" descr="" size="0x20.0" >
	<field name="device_id" descr="PCI device ID. For specific device IDs, see Table 12, &quot;Switch Supported PCI Device IDs,&quot; on page 256" access="RO" offset="0x0.0" size="0x0.16" />
	<field name="device_hw_revision" descr="See Table 238, &quot;Device HW Revision Descriptions,&quot; on page 236" access="RO" offset="0x0.16" size="0x0.16" />
	<field name="pvs" descr="Process Voltage Scaling\;Supported nominal V_CORE voltage (in 50mV units) for the device." access="RO" offset="0x4.0" size="0x0.5" />
	<field name="technology" descr="Process technology\;0: N/A\;1: 40nm\;2: 28nm\;3: 16nm\;4: 7nm\;5: 5nm\;6-31: Reserved" access="RO" offset="0x4.11" size="0x0.5" />
	<field name="num_ports" descr="Number of physical port the device supports.\;For Retimer: returns the number of data path \;" access="RO" offset="0x4.16" size="0x0.8" />
	<field name="hw_dev_id" descr="The PCI device-ID of the NIC/HCA in recovery (Livefish) mode." access="RO" offset="0x8.0" size="0x0.16" />
	<field name="manufacturing_base_mac_47_32" descr="MSB of the &quot;base&quot; MAC address of the NIC that was allocate during manufacturing. The NIC derives the MAC addresses for the different PCI PFs from this MAC address. This parameter can be used as a canonical unique identifier of the NIC.\;manufacturing_base_mac of value 0 means field is not supported." access="RO" offset="0x10.0" size="0x0.16" />
	<field name="ga" descr="[DWIP]\;Geographical Address\;0: ASIC 0\;1: ASIC 1\;2: ASIC 2\;3: ASIC 3\;Valid for multi ASIC platforms only" access="RO" offset="0x10.16" size="0x0.2" />
	<field name="chip_type" descr="[DWIP]\;Chip Type\;0: Real chip\;1: Emulation\;2: ChipSim\;3: SimX \;Supported from Quantum-3 and ArcusE" access="RO" offset="0x10.24" size="0x0.4" />
	<field name="manufacturing_base_mac_31_0" descr="LSB of the &quot;base&quot; MAC address of the NIC that was allocate during manufacturing. The NIC derives the MAC addresses for the different PCI PFs from this MAC address. This parameter can be used as a canonical unique identifier of the NIC.\;manufacturing_base_mac of value 0 means field is not supported." access="RO" offset="0x14.0" size="0x4.0" />
	<field name="uptime" descr="Time (in secs.) since last reset0" access="RO" offset="0x1C.0" size="0x4.0" />
</node>

<node name="mgir_sw_info_ext" descr="" size="0x20.0" >
	<field name="sub_minor" descr="Sub-minor Driver version number.\;" access="RO" offset="0x0.0" size="0x0.8" />
	<field name="minor" descr="Minor Driver version number.\;" access="RO" offset="0x0.8" size="0x0.8" />
	<field name="major" descr="Major Driver version number.\;" access="RO" offset="0x0.16" size="0x0.8" />
	<field name="rom3_type" descr="ROM 3 type:\;0x0: none\;0x1: Flexboot\;0x2: UEFI\;0x3: UEFI-CLP\;0x4: NVME\;0x5: FCODE\;0x6: UEFI Virtio net\;0x7: UEFI Virtio blk\;0x8: PXE Virtio net\;0x9-0xF: Reserved" access="RO" offset="0x4.0" size="0x0.4" />
	<field name="rom3_arch" descr="Arch type of ROM 3:\;0x0: unspecified\;0x1: AMD64 - x86 64bit architecture\;0x2: AARCH64 - ARM Architecture 64 bits\;0x3: AMD64_AARCH64 - ROM code supporting both AMD64 and AARCH64 architectures\;0x4: IA32 - Intel Architecture 32 bits" access="RO" offset="0x4.4" size="0x0.4" />
	<field name="rom2_type" descr="ROM 2type:\;0x0: none\;0x1: Flexboot\;0x2: UEFI\;0x3: UEFI-CLP\;0x4: NVME\;0x5: FCODE\;0x6: UEFI Virtio net\;0x7: UEFI Virtio blk\;0x8: PXE Virtio net\;0x9-0xF: Reserved" access="RO" offset="0x4.8" size="0x0.4" />
	<field name="rom2_arch" descr="Arch type of ROM 2:\;0x0: unspecified\;0x1: AMD64 - x86 64bit architecture\;0x2: AARCH64 - ARM Architecture 64 bits\;0x3: AMD64_AARCH64 - ROM code supporting both AMD64 and AARCH64 architectures\;0x4: IA32 - Intel Architecture 32 bits" access="RO" offset="0x4.12" size="0x0.4" />
	<field name="rom1_type" descr="ROM 1type:\;0x0: none\;0x1: Flexboot\;0x2: UEFI\;0x3: UEFI-CLP\;0x4: NVME\;0x5: FCODE\;0x6: UEFI Virtio net\;0x7: UEFI Virtio blk\;0x8: PXE Virtio net\;0x9-0xF: Reserved" access="RO" offset="0x4.16" size="0x0.4" />
	<field name="rom1_arch" descr="Arch type of ROM 1:\;0x0: unspecified\;0x1: AMD64 - x86 64bit architecture\;0x2: AARCH64 - ARM Architecture 64 bits\;0x3: AMD64_AARCH64 - ROM code supporting both AMD64 and AARCH64 architectures\;0x4: IA32 - Intel Architecture 32 bits" access="RO" offset="0x4.20" size="0x0.4" />
	<field name="rom0_type" descr="ROM 0 type:\;0x0: none\;0x1: Flexboot\;0x2: UEFI\;0x3: UEFI-CLP\;0x4: NVME\;0x5: FCODE\;0x6: UEFI Virtio net\;0x7: UEFI Virtio blk\;0x8: PXE Virtio net\;0x9-0xF: Reserved" access="RO" offset="0x4.24" size="0x0.4" />
	<field name="rom0_arch" descr="Arch type of ROM 0:\;0x0: unspecified\;0x1: AMD64 - x86 64bit architecture\;0x2: AARCH64 - ARM Architecture 64 bits\;0x3: AMD64_AARCH64 - ROM code supporting both AMD64 and AARCH64 architectures\;0x4: IA32 - Intel Architecture 32 bits" access="RO" offset="0x4.28" size="0x0.4" />
	<field name="rom0_version" descr="ROM 0 version." subnode="rom_version_ext" access="RO" offset="0x8.0" size="0x4.0" />
	<field name="rom1_version" descr="ROM 1 version." subnode="rom_version_ext" access="RO" offset="0xC.0" size="0x4.0" />
	<field name="rom2_version" descr="ROM 2version." subnode="rom_version_ext" access="RO" offset="0x10.0" size="0x4.0" />
	<field name="rom3_version" descr="ROM 3 version." subnode="rom_version_ext" access="RO" offset="0x14.0" size="0x4.0" />
</node>

<node name="mjtag_ext" descr="" size="0x30.0" >
	<field name="size" descr="Size of operation - relevant for JTAG interface access commands only, indicating the number of transaction bytes to execute. Maximum size supported is 40.\;Note: when size=0, no operation is performed (clock is not toggled). The tdo is sampled and provided in the response at jtag_transaction_set_0." access="WO" offset="0x0.0" size="0x0.8" />
	<field name="sequence_number" descr="Command sequence number - to prevent re-execution of the same command due to command retransmission, this command includes a sequence number.\;The enable and disable commands MUST be issues with sequence_number = 0 while any JTAG access command must increase the sequence_number by 1 (the first JTAG access command should start at sequence_number = 1)." access="WO" offset="0x0.24" size="0x0.4" />
	<field name="cmd" descr="Command\;0 - JTAG interface disable - JTAG interface is disabled\;1 - JTAG interface enable - enabling JTAG interface\;2 - JTAG interface access" access="RW" offset="0x0.30" size="0x0.2" />
	<field name="jtag_transaction_set" descr="See Table 83, &quot;JTAG Transaction Set Byte Layout,&quot; on page 124" access="RW" high_bound="43" low_bound="0" offset="0x4.24" size="0x2c.0" />
</node>

<node name="mkdc_reg_ext" descr="" size="0x2c.0" >
	<field name="error_code" descr="Indicates the successful completion of the instruction or the reason it failed:\;0: OK\;1: BAD_SESSION_ID\;2: BAD_KEEP_ALIVE_COUNTER\;3: BAD_SOURCE_ADDRESS\;4: SESSION_TIMEOUT\;Other values are Reserved." access="RO" enum="OK=0x0,BAD_SESSION_ID=0x1,BAD_KEEP_ALIVE_COUNTER=0x2,BAD_SOURCE_ADDRESS=0x3,SESSION_TIMEOUT=0x4" offset="0x0.0" size="0x0.4" />
	<field name="session_id" descr="Unique debug session identifier." access="INDEX" offset="0x0.16" size="0x0.16" />
	<field name="current_keep_alive_counter" descr="Running counter that states the current sequence number of each keep-alive session." access="INDEX" offset="0x4.0" size="0x4.0" />
	<field name="next_keep_alive_counter" descr="Running counter that states the expected next sequence number of each keep-alive session." access="RO" offset="0x8.0" size="0x4.0" />
</node>

<node name="mqdik_reg_ext" descr="" size="0x208.0" >
	<field name="algorithm" descr="0: ECC. Used for any of the P256, P385, P521 curves.\;1: RSA. Used for 2048 or 4096 keys." access="RO" offset="0x0.0" size="0x0.8" />
	<field name="key_size" descr="Number of Bytes in the public_key" access="RO" offset="0x0.8" size="0x0.8" />
	<field name="status" descr="0: Key is not ready for query\;1: Key is provided in the response" access="RO" offset="0x0.16" size="0x0.8" />
	<field name="public_key" descr="Public-key value, per the specific algorithm." access="RO" high_bound="127" low_bound="0" offset="0x8.0" size="0x200.0" />
</node>

<node name="mqis_reg_ext" descr="" size="0x18.0" >
	<field name="info_type" descr="Type of information string to be queried:\;0x0: VPD - Read the PCI Vital Product Data capability content.\;0x1: MODEL_NAME\;0x2: MODEL_DESCRIPTION\;0x3: IMAGE_VSD\;0x4: DEVICE_VSD\;0x5: ROM_INFO\;other values are reserved." access="INDEX" enum="MODEL_NAME=0x1,MODEL_DESCRIPTION=0x2,IMAGE_VSD=0x3,DEVICE_VSD=0x4,ROM_INFO=0x5" offset="0x0.0" size="0x0.8" />
	<field name="info_length" descr="Total size of the information string, according to info_type. Value given in bytes." access="RO" offset="0x4.0" size="0x0.16" />
	<field name="read_length" descr="Number of bytes requested. The device returns the number of bytes actually read." access="RW" offset="0x8.0" size="0x0.16" />
	<field name="read_offset" descr="Offset in bytes of the first byte requested to read." access="INDEX" offset="0x8.16" size="0x0.16" />
	<field name="info_string" descr="Information string accessed, according to info_type. If the information is not available, a NULL string is returned." access="RO" high_bound="7" low_bound="0" offset="0x10.24" size="0x8.0" />
</node>

<node name="mrsi_ext" descr="" size="0x40.0" >
	<field name="reset_reason" descr="Reset/shutdown reason\;0: cold reset - A reset triggered following application of power to the component. 1: warm reset - A reset triggered without removal and re-application of power to the device" access="RO" offset="0x4.0" size="0x0.4" />
	<field name="crts" descr="Timestamp (number of clock cycles) since last cold reset" subnode="uint64" access="RO" offset="0x8.0" size="0x8.0" />
</node>

<node name="mrsr_ext" descr="" size="0x8.0" >
	<field name="command" descr="Reset/shutdown command\;0: clear state of reset_at_pci_disable\;1: software reset (switch soft reset). From Quantum-3 (IB) and on must not be used for managed switches. Also must not be used from Spectrum-4 and on (ETH).\;6: reset_at_pci_disable - reset will be done at PCI_DISABLE. See MCAM bit48\;\;For Retimer: only command = 1 is supported.\;\;" access="WO" offset="0x0.0" size="0x0.4" />
</node>

<node name="msgi_ext" descr="" size="0x80.0" >
	<field name="serial_number" descr="System serial number (ASCII string)" access="RO" high_bound="5" low_bound="0" offset="0x0.0" size="0x18.0" />
	<field name="part_number" descr="System part number (ASCII string)" access="RO" high_bound="4" low_bound="0" offset="0x20.0" size="0x14.0" />
	<field name="revision" descr="Revision (ASCII string)" access="RO" offset="0x38.0" size="0x4.0" />
	<field name="product_name" descr="Product Name (ASCII string)" access="RO" high_bound="15" low_bound="0" offset="0x40.0" size="0x40.0" />
</node>

<node name="mtcq_reg_ext" descr="" size="0x70.0" >
	<field name="device_index" descr="Device number.\;For gearboxes, the index represents the gearbox die.\;For cables, the index represents the module index starting at index 1 while index 0 indicates the host device." access="INDEX" offset="0x0.0" size="0x0.12" />
	<field name="status" descr="Indicates the status of the desired token we are generating the challenge for.\;0x0 - OK\;0x1 - TOKEN_ALREADY_APPLIED\;0x2 - TOKEN_NOT_SUPPORTED\;0x3 - NO_KEY_CONFIGURED (there is no public_key that can be used for this token) \;0x4 - INTERFACE_NOT_ALLOWED (asking for local token from remote interface, or remote token from local interface)" access="RO" offset="0x0.16" size="0x0.8" />
	<field name="token_opcode" descr="The token which a challenge is generated for.\;0: RMCS\;1: RMDT\;2: CRCS - supported from Spectrum-4 and above\;3: CRDT - supported from Spectrum-4 and above\;Other: Reserved" access="INDEX" offset="0x0.24" size="0x0.8" />
	<field name="keypair_uuid" descr="The UUID of the key used to generate the challenge." access="RO" high_bound="3" low_bound="0" offset="0x4.0" size="0x10.0" />
	<field name="base_mac" descr="Device base MAC address / unique identifier." subnode="uint64" access="RO" offset="0x14.0" size="0x8.0" />
	<field name="psid" descr="Device PSID" access="RO" high_bound="3" low_bound="0" offset="0x1C.0" size="0x10.0" />
	<field name="fw_version_39_32" descr="Device FW version" access="RO" offset="0x2C.0" size="0x0.8" />
	<field name="fw_version_31_0" descr="Device FW version" access="RO" offset="0x30.0" size="0x4.0" />
	<field name="source_address" descr="Source address of debug requester. DLID for Infiniband, ETH / IBg2 - TBD.\;Valid only for RMCS/RMDT." access="RO" high_bound="3" low_bound="0" offset="0x34.0" size="0x10.0" />
	<field name="session_id" descr="Unique debug session identifier. \;See details in REMOTE_DEBUG_KEEP_ALIVE.\;Valid only for RMCS." access="RO" offset="0x44.0" size="0x0.16" />
	<field name="challenge_version" descr="Version of the challenge format." access="RO" offset="0x44.24" size="0x0.8" />
	<field name="challenge" descr="Random generated field. Used for randomness and replay-protection." access="RO" high_bound="7" low_bound="0" offset="0x48.0" size="0x20.0" />
</node>

<node name="mtecr_ext" descr="" size="0x60.0" >
	<field name="sensor_count" descr="Number of sensors supported by the ASIC+platform\;This includes the ASIC, ambient sensors, module sensors, Gearboxes etc. \;This actually is equal to sum of all &apos;1&apos; in sensor_map\;\;Known sensors:\;0: current asic temp, FW exposes current max(all diode temp sensors)\;1..62: ambient, supported only for unmanaged switch, defined by ini\;64..255: modules\;256..288: Gearbox\;289..704: reserved for future" access="RO" offset="0x0.0" size="0x0.12" />
	<field name="last_sensor" descr="Last sensor index that is available in the system to read from.\;e.g. when 32modules: 64+32-1 = 95" access="RO" offset="0x0.16" size="0x0.12" />
	<field name="internal_sensor_count" descr="Number of sensors supported by the device that are on the ASIC. \;Exposes how many ASIC diodes exist. \;The FW exposes all of them as sensor[0]" access="RO" offset="0x4.0" size="0x0.7" />
	<field name="slot_index" descr="Slot index\;0: Main board" access="INDEX" offset="0x4.28" size="0x0.4" />
	<field name="sensor_map" descr="Mapping of system sensors supported by the device. Each bit represents a sensor.\;This field is size variable based on the last_sensor field and in granularity of 32bits.\;Per bit:\;0: Not connected or not supported\;1: Supports temperature measurements\;\;In case of last_sensor = 704 (22*32):\;sensor_warning[0] bit31 is sensor_warning[703]\;sensor_warning[0] bit0 is sensor_warning[703-31]\;sensor_warning[21] bit31 is sensor_warning[31]\;sensor_warning[21] bit0 is sensor_warning[0]\;\;In case if last_sensor = 259 (22*32):\;Note: roundup(259,32)=288\;sensor_warning[0] bit31 is sensor_warning[287]\;sensor_warning[0] bit0 is sensor_warning[287-31=256]\;sensor_warning[8] bit31 is sensor_warning[31]\;sensor_warning[8] bit0 is sensor_warning[0]\;sensor_warning[9..21] are not used\;\;64-192 of sensor_index are mapped to the modules sequentially (module 0 is mapped to sensor_index 64, module 1 to sensor_index 65 and so on)." access="RO" high_bound="21" low_bound="0" offset="0x8.0" size="0x58.0" />
</node>

<node name="mtewe_ext" descr="" size="0x5c.0" >
	<field name="sensor_count" descr="Number of sensors supported by the device\;This includes the ASIC, ambient sensors, Gearboxes etc." access="RO" offset="0x0.0" size="0x0.12" />
	<field name="slot_index" descr="Slot index\;0: Main board" access="INDEX" offset="0x0.12" size="0x0.4" />
	<field name="last_sensor" descr="Last sensor index that is available in the system to read from." access="RO" offset="0x0.16" size="0x0.12" />
	<field name="sensor_warning" descr="Bit vector indicating which of the sensor reading is above threshold.\;This field is size dependent and based on last_sensor field and in granularity of 32bits.\;\;In case of last_sensor = 704 (22*32):\;sensor_warning[0] bit31 is sensor_warning[703]\;sensor_warning[0] bit0 is sensor_warning[703-31]\;sensor_warning[21] bit31 is sensor_warning[31]\;sensor_warning[21] bit0 is sensor_warning[0]\;\;In case if last_sensor = 259 (22*32):\;Note: roundup(259,32)=288\;sensor_warning[0] bit31 is sensor_warning[287]\;sensor_warning[0] bit0 is sensor_warning[287-31=256]\;sensor_warning[8] bit31 is sensor_warning[31]\;sensor_warning[8] bit0 is sensor_warning[0]\;sensor_warning[9..21] are not used" access="RO" high_bound="21" low_bound="0" offset="0x4.0" size="0x58.0" />
</node>

<node name="mtmp_ext" descr="" size="0x20.0" >
	<field name="sensor_index" descr="Sensors index\;0: current asic temp, FW exposes current max(all diode temp sensors)\;1..62: ambient, supported only for unmanaged switch, defined by ini\;64..255: modules 256..288: Gearbox\;289..704: reserved for future" access="INDEX" offset="0x0.0" size="0x0.12" />
	<field name="slot_index" descr="Slot index\;0: Main board" access="INDEX" offset="0x0.16" size="0x0.4" />
	<field name="temperature" descr="Temperature reading from the sensor. \;Units of 0.125 Celsius degrees.\;For negative values 2&apos;s complement is used (for example: -3.25 Celsius will read as 0xFFE6)" access="RO" offset="0x4.0" size="0x0.16" />
	<field name="max_temperature" descr="The highest measured temperature from the sensor.\;Reserved when mte = 0\;Cleared by mtr = 1\;Valid only when i = 0\;" access="RO" offset="0x8.0" size="0x0.16" />
	<field name="sdme" descr="Shut Down Events Modify Set Enable:\;0: all fields are set\;1: only sdee field is set, all other fields reserved" access="OP" offset="0x8.28" size="0x0.1" />
	<field name="weme" descr="Warning Events Modify Set Enable:\;0: all fields are set\;1: only tee field is set, all other fields reserved" access="OP" offset="0x8.29" size="0x0.1" />
	<field name="mtr" descr="Max Temperature Reset:\;0: do not modify the value of the max temperature register\;1: clear the value of the max temperature register" access="OP" offset="0x8.30" size="0x0.1" />
	<field name="mte" descr="Max Temperature Enable:\;0: disable measuring the max temperature on a sensor\;1: enables measuring the max temperature on a sensor" access="RW" offset="0x8.31" size="0x0.1" />
	<field name="temperature_threshold_hi" descr="temperature_threshold_hi refers to the high threshold of Warning Event. \;If the sensor temperature measurement is above the threshold (and events are enabled), an event will be generated.\;threshold_hi and threshold_lo implements hysteresis mechanism of the threshold preventing toggling of the indication.\;Note that temperature_threshold_hi must be equal or lower than the system requirement.\;System requirement for module is the module warning temperature.\;System requirement for board/silicon sensors is according to product information parameters\;Note that the temperature threshold can be used to generate an event message or an interrupt using GPIO" access="RW" offset="0xC.0" size="0x0.16" />
	<field name="sdee" descr="Temperature Shut Down Event Enable (MTSDE Register)\;0: do_not_generate_event\;1: generate_event\;2: generate_single_event\;\;Supported in downstream devices (devices on slots)." access="RW" offset="0xC.28" size="0x0.2" />
	<field name="tee" descr="Temperature Warning Event Enable (MTEWE Register)\;0: do_not_generate_event\;1: generate_event\;2: generate_single_event\;\;" access="RW" enum="do_not_generate_event=0x0,generate_event=0x1,generate_single_event=0x2" offset="0xC.30" size="0x0.2" />
	<field name="temperature_threshold_lo" descr="temperature_threshold_lo refers to the low threshold of Warning Event. \;The offset threshold_lo implements the lower threshold for the hysteresis mechanism of over temperature alert. Once alert is set, if the temperature goes below this threshold, the alert is cleared.\;Note that temperature_threshold_lo must be at least 5 degrees lower than temperature_threshold_hi" access="RW" offset="0x10.0" size="0x0.16" />
	<field name="sensor_name_hi" descr="Sensor Name\;8 character long sensor name\;" access="RO" offset="0x18.0" size="0x4.0" />
	<field name="sensor_name_lo" descr="Sensor Name\;8 character long sensor name\;" access="RO" offset="0x1C.0" size="0x4.0" />
</node>

<node name="pemi_SNR_Samples_ext" descr="" size="0xf8.0" >
	<field name="snr_media_lane1" descr="SNR value on the media lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x0.0" size="0x0.16" />
	<field name="snr_media_lane0" descr="SNR value on the media lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x0.16" size="0x0.16" />
	<field name="snr_media_lane3" descr="SNR value on the media lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x4.0" size="0x0.16" />
	<field name="snr_media_lane2" descr="SNR value on the media lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x4.16" size="0x0.16" />
	<field name="snr_media_lane5" descr="SNR value on the media lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x8.0" size="0x0.16" />
	<field name="snr_media_lane4" descr="SNR value on the media lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x8.16" size="0x0.16" />
	<field name="snr_media_lane7" descr="SNR value on the media lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0xC.0" size="0x0.16" />
	<field name="snr_media_lane6" descr="SNR value on the media lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0xC.16" size="0x0.16" />
	<field name="snr_host_lane1" descr="SNR value on the host lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x10.0" size="0x0.16" />
	<field name="snr_host_lane0" descr="SNR value on the host lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x10.16" size="0x0.16" />
	<field name="snr_host_lane3" descr="SNR value on the host lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x14.0" size="0x0.16" />
	<field name="snr_host_lane2" descr="SNR value on the host lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x14.16" size="0x0.16" />
	<field name="snr_host_lane5" descr="SNR value on the host lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x18.0" size="0x0.16" />
	<field name="snr_host_lane4" descr="SNR value on the host lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x18.16" size="0x0.16" />
	<field name="snr_host_lane7" descr="SNR value on the host lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x1C.0" size="0x0.16" />
	<field name="snr_host_lane6" descr="SNR value on the host lane &lt;i&gt;. In unit scale of 1/256 dB.\;The SNR value represents the electrical signal-to-noise ratio on an optical lane, and is defined as the minimum of the three individual eye SNR values." access="RO" offset="0x1C.16" size="0x0.16" />
</node>

<node name="pemi_ext" descr="" size="0x100.0" >
	<field name="status" descr="The status of the page reading:\;0: READ_SUCCESSFUL - read operation was successful\;1: OPERATION_NOT_SUPPORTED\;2: NO_EEPROM_MODULE - no response from module&apos;s \;EEPROM.\;3: MODULE_NOT_CONNECTED - no module present indication.\;4: I2C_ERROR - an Error occurred while trying to access the module&apos;s EEPROM using I2C.\;5: MODULE_IN_PROGRESS - indicates that the module is still busy.\;6: CDB_STSATUS_FAILED - the CDB return status is FAILED." access="RO" enum="READ_SUCCESSFUL=0x0,OPERATION_NOT_SUPPORTED=0x1,NO_EEPROM_MODULE=0x2,MODULE_NOT_CONNECTED=0x3,I2C_ERROR=0x4,MODULE_IN_PROGRESS=0x5,CDB_STSATUS_FAILED=0x6" offset="0x0.0" size="0x0.8" />
	<field name="lp_msb" descr="Local port number [9:8]\;\;for Retimer: reserved" access="INDEX" offset="0x0.12" size="0x0.2" />
	<field name="pnat" descr="Port number access type. determines the way local_port is \;interpreted:\;0: Local_port_number\;1: IB_port_number\;\;for Retimer: reserved" access="INDEX" offset="0x0.14" size="0x0.2" />
	<field name="local_port" descr="Local port number\;for Retimer: Data path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="page_select" descr="The user can select to read a sampled data page or a properties page.\;\;1: SNR_Samples\;16: Module_Status_Properties" access="INDEX" enum="SNR_Samples=0x1" offset="0x4.0" size="0x0.5" />
	<field name="group_cap_mask" descr="Group capability mask:\;Bit 1: SNR" access="RO" enum="SNR=0x2" offset="0x4.16" size="0x0.16" />
	<field name="page_data" descr="Page data:\;Table 832, &quot;SNR Samples page - Layout,&quot; on page 874" subnode="pemi_page_data_auto_ext" access="RO" offset="0x8.0" size="0xf8.0" union_selector="$(parent).page_select" />
</node>

<node name="pemi_page_data_auto_ext" descr="" attr_is_union="1" size="0xf8.0" >
	<field name="pemi_SNR_Samples_ext" descr="" subnode="pemi_SNR_Samples_ext" offset="0x0.0" selected_by="SNR_Samples" size="0xf8.0" />
</node>

<node name="phy_error_cntrs_ext" descr="" size="0x54.0" >
	<field name="time_since_last_clear_high" descr="The time passed since the last counters clear event in msec." access="RO" offset="0x0.0" size="0x4.0" />
	<field name="time_since_last_clear_low" descr="The time passed since the last counters clear event in msec." access="RO" offset="0x4.0" size="0x4.0" />
	<field name="phy_received_bits_high" descr="This counter provides information on the total amount of traffic (bits) received." access="RO" offset="0x8.0" size="0x4.0" />
	<field name="phy_received_bits_low" descr="This counter provides information on the total amount of traffic (bits) received." access="RO" offset="0xC.0" size="0x4.0" />
	<field name="phy_raw_errors_lane0_high" descr="This counter provides information on error bits that were identified on lane 0. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 0" access="RO" offset="0x10.0" size="0x4.0" />
	<field name="phy_raw_errors_lane0_low" descr="This counter provides information on error bits that were identified on lane 0. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 0" access="RO" offset="0x14.0" size="0x4.0" />
	<field name="phy_raw_errors_lane1_high" descr="This counter provides information on error bits that were identified on lane 1. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 1" access="RO" offset="0x18.0" size="0x4.0" />
	<field name="phy_raw_errors_lane1_low" descr="This counter provides information on error bits that were identified on lane 1. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 1" access="RO" offset="0x1C.0" size="0x4.0" />
	<field name="phy_raw_errors_lane2_high" descr="This counter provides information on error bits that were identified on lane 2. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 2" access="RO" offset="0x20.0" size="0x4.0" />
	<field name="phy_raw_errors_lane2_low" descr="This counter provides information on error bits that were identified on lane 2. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 2" access="RO" offset="0x24.0" size="0x4.0" />
	<field name="phy_raw_errors_lane3_high" descr="This counter provides information on error bits that were identified on lane 3. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 3" access="RO" offset="0x28.0" size="0x4.0" />
	<field name="phy_raw_errors_lane3_low" descr="This counter provides information on error bits that were identified on lane 3. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 3" access="RO" offset="0x2C.0" size="0x4.0" />
	<field name="phy_raw_errors_lane4_high" descr="This counter provides information on error bits that were identified on lane 4. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 4" access="RO" offset="0x30.0" size="0x4.0" />
	<field name="phy_raw_errors_lane4_low" descr="This counter provides information on error bits that were identified on lane 4. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 4" access="RO" offset="0x34.0" size="0x4.0" />
	<field name="phy_raw_errors_lane5_high" descr="This counter provides information on error bits that were identified on lane 5. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 5" access="RO" offset="0x38.0" size="0x4.0" />
	<field name="phy_raw_errors_lane5_low" descr="This counter provides information on error bits that were identified on lane 5. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 5" access="RO" offset="0x3C.0" size="0x4.0" />
	<field name="phy_raw_errors_lane6_high" descr="This counter provides information on error bits that were identified on lane 6. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 6" access="RO" offset="0x40.0" size="0x4.0" />
	<field name="phy_raw_errors_lane6_low" descr="This counter provides information on error bits that were identified on lane 6. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 6" access="RO" offset="0x44.0" size="0x4.0" />
	<field name="phy_raw_errors_lane7_high" descr="This counter provides information on error bits that were identified on lane 7. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 7" access="RO" offset="0x48.0" size="0x4.0" />
	<field name="phy_raw_errors_lane7_low" descr="This counter provides information on error bits that were identified on lane 7. \;In PRBS test mode, indicates the number of PRBS errors\;on lane 7" access="RO" offset="0x4C.0" size="0x4.0" />
</node>

<node name="rom_version_ext" descr="" size="0x4.0" >
	<field name="build" descr="Build version" access="RO" offset="0x0.0" size="0x0.16" />
	<field name="minor" descr="Minor version" access="RO" offset="0x0.16" size="0x0.8" />
	<field name="major" descr="Major version" access="RO" offset="0x0.24" size="0x0.8" />
</node>

<node name="rtcap_reg_ext" descr="" size="0x14.0" >
	<field name="reg_group" descr="access register group ID \;0: RegID_0x6C00 to 0x6C7F\;1: RegID 0x5000 to 0x507F" access="INDEX" offset="0x0.0" size="0x0.4" />
	<field name="access_reg_cap_mask" descr="supported access registers bit-mask, if the bit is set, the register is supported\;\;for reg_group0:\;\;bit 0: 0x6C00 \;bit 1: 0x6C01 (RTFC)\;bit 2: 0x6C02 (RTXBCFG)\;...\;bit 127: 0x6C7F (RRAR)\;\;\;for reg_group1:\;bit 0: 0x5000\;bit 1: 0x5001 (PCAP)\;...\;bit 127: 0x507F (PCAM)" access="RO" high_bound="3" low_bound="0" offset="0x4.0" size="0x10.0" />
</node>

<node name="rtcc_lane_info_ext" descr="" size="0x4.0" >
	<field name="tx_line" descr="mapping the Physical lane for Data Path lane, rx host side\;\;for gearbox: tx_2\;(host side for even lane number, line side for odd lane number)" access="RW" offset="0x0.0" size="0x0.4" />
	<field name="rx_line" descr="mapping the Physical lane for Data Path lane, rx host side\;\;for gearbox: rx_2\;(host side for even lane number, line side for odd lane number)" access="RW" offset="0x0.5" size="0x0.4" />
	<field name="tx_host" descr="mapping the Physical lane for Data Path lane, rx host side\;\;for gearbox: tx_1\;(host side for even lane number, line side for odd lane number)" access="RW" offset="0x0.10" size="0x0.4" />
	<field name="rx_host" descr="mapping the Physical lane for Data Path lane, rx host side\;\;for gearbox: rx_1\;(host side for even line number, line side for odd line number)" access="RW" offset="0x0.15" size="0x0.4" />
	<field name="gearbox" descr="0: disable\;1: gearbox (2 -&gt;1)\;2: reversed gearbox (1-&gt;2)\;\;if gearboxing is enable, it needs to be on both near lanes.\;the even lane number will set the host side, \;and the odd lane number will set the line side" access="RW" offset="0x0.28" size="0x0.2" />
	<field name="override" descr="0: values stay the same, ignore all the parameters\;1: override crossbar values." access="RW" offset="0x0.31" size="0x0.1" />
</node>

<node name="rtcc_reg_ext" descr="" size="0x24.0" >
	<field name="error" descr="error return (bit-mask)\;bit 0: lane0_error\;bit 1: lane1_error\;bit 2: lane2_error\;bit 3: lane3_error\;bit 4: lane4_error\;bit 5: lane5_error\;bit 6: lane6_error\;bit 7: lane7_error" access="RO" enum="lane0_error=0x1,lane1_error=0x2,lane2_error=0x4,lane3_error=0x8,lane4_error=0x10,lane5_error=0x20,lane6_error=0x40,lane7_error=0x80" offset="0x0.0" size="0x0.8" />
	<field name="partial_retimed" descr="can be change only when all data paths are down.\;0x0: no_change\;0x1: full_retimed\;0x2: half_retimed_egress\;0x3: half_retimed_ingress" access="RW" enum="no_change=0x0,full_retimed=0x1,half_retimed_egress=0x2,half_retimed_ingress=0x3" offset="0x0.27" size="0x0.2" />
	<field name="lane" descr="configuration for lane 0-7" subnode="rtcc_lane_info_ext" access="RW" high_bound="7" low_bound="0" offset="0x4.0" size="0x20.0" />
</node>

<node name="rtcde_reg_ext" descr="" size="0x14.0" >
	<field name="data_path" descr="data path number. \;ignore if all_lanes=0x1" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="all_lanes" descr="0x0: return only the lanes relevant to the chosen data path. Lanes will be aligned to start from lane 0\;0x1: return the status on all of the retimer lanes at once (ignore data_path)." access="INDEX" offset="0x0.24" size="0x0.1" />
	<field name="lol_host" descr="loss of lock Rx host side\;Lane bit mask" access="RO" offset="0x4.0" size="0x0.8" />
	<field name="lol_line" descr="loss of lock Rx line side\;Lane bit mask" access="RO" offset="0x4.16" size="0x0.8" />
	<field name="output_valid_host" descr="transmitting pass-through valid data on ingress path. Line Rx to Host Tx\;Lane bit mask" access="RO" offset="0x8.0" size="0x0.8" />
	<field name="output_valid_line" descr="transmitting pass-through valid data on egress path. Host Rx to Line Tx\;Lane bit mask" access="RO" offset="0x8.16" size="0x0.8" />
	<field name="adaptive_eq_fail_host" descr="Rx EQ or LT failed on host side\;Lane bit mask" access="RO" offset="0xC.0" size="0x0.8" />
	<field name="adaptive_eq_fail_line" descr="Rx EQ or LT failed on line side\;Lane bit mask" access="RO" offset="0xC.16" size="0x0.8" />
	<field name="fec_am_lock_host" descr="AM FEC host side locked\;Lane bit mask" access="RO" offset="0x10.0" size="0x0.8" />
	<field name="fec_am_lock_line" descr="AM FEC line side locked\;Lane bit mask" access="RO" offset="0x10.16" size="0x0.8" />
</node>

<node name="rtdpc_reg_ext" descr="" size="0x8.0" >
	<field name="line_width" descr="0: unmap datapath\;1: x1 \;2: x2 \;4: x4 \;8: x8" access="RW" offset="0x0.0" size="0x0.4" />
	<field name="host_width" descr="0x0 : unmap datapath\;0x1: x1 \;0x2: x2 \;0x4: x4 \;0x8: x8" access="RW" offset="0x0.5" size="0x0.4" />
	<field name="status" descr="0x0: done\;0x1: data_path_already_mapped - in order to map datapath, need to be unmaped first.\;0x2: width_missmatch - width does not align with RTCC configuration, lane_sel doesn&apos;t match widths \;0x3: lanes_already_in_use\;0x4: invalid_gearbox\;0x5: datapath_index_out_of_bound" access="RO" enum="done=0x0,data_path_already_mapped=0x1,width_missmatch=0x2,lanes_already_in_use=0x3,invalid_gearbox=0x4,datapath_index_out_of_bound=0x5" offset="0x0.10" size="0x0.4" />
	<field name="data_path" descr="Data path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="lane_sel" descr="select the associated lanes to the data path (bit mask)" access="RW" offset="0x4.0" size="0x0.8" />
</node>

<node name="rtdsm_reg_ext" descr="" size="0x18.0" >
	<field name="data_path" descr="Data Path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="dp_fsm" descr="Data path Finite State Machine\;0x0: Disable\;0x1: EgSleep\;0x2: EgRcvDet\;0x3: EgSigDet\;0x4: ingDetectable\;0x5: EgAN\;0x6: IngAN\;0x7: Adaptation - Rx Tuning or LT\;0x8: Config\;0x9: LinkUp\;0xa: close\;0xb: SignalDetect\;0xc: TestMode\;rest are reserved" access="RO" enum="Disable=0x0,EgSleep=0x1,EgRcvDet=0x2,EgSigDet=0x3,ingDetectable=0x4,EgAN=0x5,IngAN=0x6,Adaptation=0x7,Config=0x8,LinkUp=0x9,close=0xa,SignalDetect=0xb,TestMode=0xc" offset="0x4.0" size="0x0.4" />
	<field name="lt_fsm_host_lane0" descr="Link Training Finite State Machine on Host side for each lane\;0: No_LT\;1: INITIALIZE\;2: SEND_TF\;3: NLTN\;4: TRAIN_LOCAL\;5: TRAIN_REMOTE\;6: LINK_READY\;7: SEND_DATA\;8: TIMEOUT\;9: QUIT\;10: TRAINING_FAILD\;others are reserved" access="RO" offset="0x8.0" size="0x0.4" />
	<field name="lt_fsm_host_lane1" descr="Link Training Finite State Machine on Host side for each lane\;0: No_LT\;1: INITIALIZE\;2: SEND_TF\;3: NLTN\;4: TRAIN_LOCAL\;5: TRAIN_REMOTE\;6: LINK_READY\;7: SEND_DATA\;8: TIMEOUT\;9: QUIT\;10: TRAINING_FAILD\;others are reserved" access="RO" offset="0x8.4" size="0x0.4" />
	<field name="lt_fsm_host_lane2" descr="Link Training Finite State Machine on Host side for each lane\;0: No_LT\;1: INITIALIZE\;2: SEND_TF\;3: NLTN\;4: TRAIN_LOCAL\;5: TRAIN_REMOTE\;6: LINK_READY\;7: SEND_DATA\;8: TIMEOUT\;9: QUIT\;10: TRAINING_FAILD\;others are reserved" access="RO" offset="0x8.8" size="0x0.4" />
	<field name="lt_fsm_host_lane3" descr="Link Training Finite State Machine on Host side for each lane\;0: No_LT\;1: INITIALIZE\;2: SEND_TF\;3: NLTN\;4: TRAIN_LOCAL\;5: TRAIN_REMOTE\;6: LINK_READY\;7: SEND_DATA\;8: TIMEOUT\;9: QUIT\;10: TRAINING_FAILD\;others are reserved" access="RO" offset="0x8.12" size="0x0.4" />
	<field name="lt_fsm_host_lane4" descr="Link Training Finite State Machine on Host side for each lane\;0: No_LT\;1: INITIALIZE\;2: SEND_TF\;3: NLTN\;4: TRAIN_LOCAL\;5: TRAIN_REMOTE\;6: LINK_READY\;7: SEND_DATA\;8: TIMEOUT\;9: QUIT\;10: TRAINING_FAILD\;others are reserved" access="RO" offset="0x8.16" size="0x0.4" />
	<field name="lt_fsm_host_lane5" descr="Link Training Finite State Machine on Host side for each lane\;0: No_LT\;1: INITIALIZE\;2: SEND_TF\;3: NLTN\;4: TRAIN_LOCAL\;5: TRAIN_REMOTE\;6: LINK_READY\;7: SEND_DATA\;8: TIMEOUT\;9: QUIT\;10: TRAINING_FAILD\;others are reserved" access="RO" offset="0x8.20" size="0x0.4" />
	<field name="lt_fsm_host_lane6" descr="Link Training Finite State Machine on Host side for each lane\;0: No_LT\;1: INITIALIZE\;2: SEND_TF\;3: NLTN\;4: TRAIN_LOCAL\;5: TRAIN_REMOTE\;6: LINK_READY\;7: SEND_DATA\;8: TIMEOUT\;9: QUIT\;10: TRAINING_FAILD\;others are reserved" access="RO" offset="0x8.24" size="0x0.4" />
	<field name="lt_fsm_host_lane7" descr="Link Training Finite State Machine on Host side for each lane\;0: No_LT\;1: INITIALIZE\;2: SEND_TF\;3: NLTN\;4: TRAIN_LOCAL\;5: TRAIN_REMOTE\;6: LINK_READY\;7: SEND_DATA\;8: TIMEOUT\;9: QUIT\;10: TRAINING_FAILD\;others are reserved" access="RO" enum="No_LT=0x0,INITIALIZE=0x1,SEND_TF=0x2,NLTN=0x3,TRAIN_LOCAL=0x4,TRAIN_REMOTE=0x5,LINK_READY=0x6,SEND_DATA=0x7,TIMEOUT=0x8,QUIT=0x9,TRAINING_FAILD=0xa" offset="0x8.28" size="0x0.4" />
	<field name="lt_fsm_line_lane0" descr="Link Training Finite State Machine on Line side for each lane\;states are the same as above" access="RO" offset="0xC.0" size="0x0.4" />
	<field name="lt_fsm_line_lane1" descr="Link Training Finite State Machine on Line side for each lane\;states are the same as above" access="RO" offset="0xC.4" size="0x0.4" />
	<field name="lt_fsm_line_lane2" descr="Link Training Finite State Machine on Line side for each lane\;states are the same as above" access="RO" offset="0xC.8" size="0x0.4" />
	<field name="lt_fsm_line_lane3" descr="Link Training Finite State Machine on Line side for each lane\;states are the same as above" access="RO" offset="0xC.12" size="0x0.4" />
	<field name="lt_fsm_line_lane4" descr="Link Training Finite State Machine on Line side for each lane\;states are the same as above" access="RO" offset="0xC.16" size="0x0.4" />
	<field name="lt_fsm_line_lane5" descr="Link Training Finite State Machine on Line side for each lane\;states are the same as above" access="RO" offset="0xC.20" size="0x0.4" />
	<field name="lt_fsm_line_lane6" descr="Link Training Finite State Machine on Line side for each lane\;states are the same as above" access="RO" offset="0xC.24" size="0x0.4" />
	<field name="lt_fsm_line_lane7" descr="Link Training Finite State Machine on Line side for each lane\;states are the same as above" access="RO" offset="0xC.28" size="0x0.4" />
	<field name="rec_detected" descr="receiver detected (bit-mask)\;this is per lane bit mask.\;1:retimer got a receiver_detected indication during rec.detect state\;0: else\;\;this bit mask will be clear each timer we enter rec.detect state." access="RO" offset="0x10.0" size="0x0.8" />
	<field name="signal_detected" descr="signal detected (bit-mask)\;this is per lane bit mask.\;1:retimer got a signal_detected indication during signal.detect state\;0: else\;\;this bit mask will be clear each timer we enter signal.detect state." access="RO" offset="0x14.0" size="0x0.8" />
</node>

<node name="rtedc_reg_ext" descr="" size="0x14.0" >
	<field name="lane_sel" descr="select which logical lane on the data path set/get. ignored when lane_br is set." access="INDEX" offset="0x0.0" size="0x0.3" />
	<field name="data_path" descr="Data Path Number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="gain" descr="resistive part of the differential predriver degeneration circuit" access="RW" offset="0x4.0" size="0x0.4" />
	<field name="gain_ov" descr="gain override\;0 - gain will determined according to default production value\;1 - gain will be determined from gain field" access="WO" offset="0x4.29" size="0x0.1" />
	<field name="lane_br" descr="lane broadcast\;when set, lane index is ignored and set is done on all data path related lanes" access="WO" offset="0x4.30" size="0x0.1" />
	<field name="en" descr="EML driver enable:\;0: disable\;1: enable" access="RW" offset="0x4.31" size="0x0.1" />
	<field name="power_mode" descr="power mode state:\;0x00: functional state\;0x01: state 1\;0x02: state 2\;...\;...\;0xf: state 15" access="RO" offset="0x8.0" size="0x0.5" />
	<field name="cas_top" descr="Voltage at top of the EML driver cascode stack. Valid range is 2.05 to 2.25V\;value is in mV\;" access="RO" offset="0x8.16" size="0x0.16" />
</node>

<node name="rtfcr_reg_ext" descr="" size="0x8.0" >
	<field name="data_path" descr="data path number." access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="fec_admin" descr="FEC set for AM lock mechanism.\;lock mechanism will do best effort to lock on FEC AM configured.\;The specific FEC alignment markers will be based on the fec_admin field, oper speed and width stated in RTPTYS\;\;0: No_fec_set - AM FEC will not try to lock\;1: Double_KP4_FEC\;2: Quad_KP4_FEC\;3: Double_ELL_FEC\;\;Status on FEC AM can be quried via RTCDE register in fec_am_lock fields.\;When oper_speed is not supported by fec_cap fields. fec_admin is ignored.\;\;Note that when RTPAOS is toggled, from active state to down, default fec will be restored to fec_admin field." access="RW" enum="No_fec_set=0x0,Double_KP4_FEC=0x1,Quad_KP4_FEC=0x2,Double_ELL_FEC=0x3" offset="0x4.0" size="0x0.8" />
	<field name="xdr_fec_cap" descr="capability for XDR speed AM FEC lock\;Bit 0: XDR_1x_double_KP4_FEC\;Bit 1: XDR_1x_double_ELL_FEC\;Bit 2: XDR_1x_quad_KP4_FEC\;Bit 3: XDR_2x_double_KP4_FEC\;Bit 4: XDR_2x_double_ELL_FEC" access="RO" enum="XDR_1x_double_KP4_FEC=0x1,XDR_1x_double_ELL_FEC=0x2,XDR_1x_quad_KP4_FEC=0x4,XDR_2x_double_KP4_FEC=0x8,XDR_2x_double_ELL_FEC=0x10" offset="0x4.16" size="0x0.8" />
</node>

<node name="rtltc_reg_ext" descr="" size="0xc.0" >
	<field name="lane_mask" descr="for set operation, lane bitmask.\;for query operation, one-hot key." access="INDEX" offset="0x0.0" size="0x0.8" />
	<field name="data_path" descr="Data path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="side_sel" descr="select which side of the data path to address (bit- mask):\;bit 0: Ingress\;bit 1: Egress" access="INDEX" enum="Ingress=0x1,Egress=0x2" offset="0x0.24" size="0x0.2" />
	<field name="precoding_write_en" descr="precoding write enable\;While this bit is set to &apos;0&apos;- ignore all the precoding admin fields" access="INDEX" offset="0x0.30" size="0x0.1" />
	<field name="polarity_write_en" descr="Polarity write enable\;While this bit is set to &apos;0&apos;- ignore all the polarity admin fields" access="INDEX" offset="0x0.31" size="0x0.1" />
	<field name="precoding_cap" descr="Data Path precoding capability\;0x0 - no precoding available / no override capability\;Bit 0- tx precoding override possible via tx_precoding_admin field\;Bit 1- rx precoding override possible via rx_precoding_admin field" access="RO" offset="0x4.0" size="0x0.2" />
	<field name="rx_precoding_admin" descr="Data Path Rx precoding configuration override:\;0- Rx precoding disabled.\;1- Rx precoding enabled.\;2 - Auto mode. precoding will be set by the FW" access="RW" offset="0x4.3" size="0x0.2" />
	<field name="rx_precoding_oper" descr="Data Path Rx precoding operational mode\;0- Rx precoding disabled.\;1- Rx precoding enabled." access="RO" offset="0x4.6" size="0x0.2" />
	<field name="polarity_cap" descr="Data Path polarity capability\;0x0 - no tx polarity available / no override capability\;Bit 0- tx polarity override possible via tx_polarity_admin field\;Bit 1- rx polarity override possible via rx_polarity_admin field" access="RO" offset="0x4.16" size="0x0.2" />
	<field name="rx_polarity_admin" descr="Data Path Rx polarity configuration override:\;0 - Rx polarity disabled.\;1 - Rx polarity enabled." access="RW" offset="0x4.19" size="0x0.2" />
	<field name="rx_polarity_oper" descr="Data Path Rx polarity operational mode\;0 - Rx polarity disabled.\;1 - Rx polarity enabled." access="RO" offset="0x4.22" size="0x0.2" />
	<field name="tx_precoding_admin" descr="Data Path Tx precoding configuration override:\;0- Tx precoding disabled.\;1- Tx precoding enabled.\;2 - Auto mode. precoding will be set by the FW" access="RW" offset="0x8.3" size="0x0.2" />
	<field name="tx_precoding_oper" descr="Data Path Tx precoding operational mode\;0- Tx precoding disabled.\;1- Tx precoding enabled." access="RO" offset="0x8.6" size="0x0.2" />
	<field name="tx_polarity_admin" descr="Data Path Tx polarity configuration override:\;0 - Tx polarity disabled.\;1 - Tx polarity enabled." access="RW" offset="0x8.19" size="0x0.2" />
	<field name="tx_polarity_oper" descr="Data Path Tx polarity operational mode\;0 - Tx polarity disabled.\;1 - Tx polarity enabled." access="RO" offset="0x8.22" size="0x0.2" />
</node>

<node name="rtpaos_reg_ext" descr="" size="0xc.0" >
	<field name="data_path" descr="Data Path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="sleep_en" descr="Enable sleep state:\;0: start state is polling\;1: start state will be sleep instead of polling" access="RW" offset="0x4.12" size="0x0.1" />
	<field name="sleep_cap" descr="Sleep capability:\;0: Sleep state is not supported\;1: Sleep state supported" access="RO" offset="0x4.14" size="0x0.1" />
	<field name="egress_state_oper" descr="read the current operation state of the  requested datapath (egress side)\;0 - Line TX is deactivated; Host RX is deactivated\;1 - Line TX is activated; Host RX is deactivated\;2 - Line TX is deactivated; Host RX is activated\;3 -Line TX is activated; Host RX is activated\;5 - Test mode" access="RO" offset="0x8.0" size="0x0.4" />
	<field name="egress_state_admin" descr="Set the desired state of the interface (egress side)\;0 - no change\;1 - Activation of both host and line path - Mission mode\;2 - Deactivation of both host and line path - &quot;Down&quot;\;3 - Deactivation of line TX, Rx reminds in provides state\;4 - Activation of line TX, Rx reminds in provides state\;5 - Test mode\;6- Deactivation of Host Rx, Line Tx reminds in provides state\;7- Activation of Host Rx, Line Tx reminds in provides state" access="RW" offset="0x8.6" size="0x0.4" />
	<field name="ingress_state_oper" descr="Read the current operation state of the requested datapath (ingress side)\;0 -Host Tx is deactivated; Line RX is deactivated\;1- Host Tx is activated; Line RX is deactivated\;2- Host Tx is deactivated; RX is activated\;3- Host Tx is activated; RX is activated\;5 -Test mode" access="RO" offset="0x8.12" size="0x0.4" />
	<field name="ingress_state_admin" descr="Set the the desired state of the requested datapath (ingress side)\;0 - no change\;1 - Activation of both host and line path - Mission mode\;2 - Deactivation of both host and line path - &quot;Down&quot;\;3 - Deactivation of host Tx, Rx reminds in provides state\;4 - Activation of host TX, Rx reminds in provides state\;5- Test mode\;6- Deactivation of Line Rx, Host Tx reminds in provides state\;7- Activation of Line Rx, Host Tx reminds in provides state" access="RW" offset="0x8.18" size="0x0.4" />
</node>

<node name="rtpcnt_reg_counter_set_auto_ext" descr="" attr_is_union="1" size="0xa8.0" >
	<field name="phy_error_cntrs_ext" descr="" subnode="phy_error_cntrs_ext" offset="0x0.0" selected_by="Physical_Layer_Error_Counters" size="0x54.0" />
	<field name="l1_general_counters_data_low_ext" descr="" subnode="l1_general_counters_data_low_ext" offset="0x0.0" selected_by="L1_General_counters_Data_Low" size="0x80.0" />
	<field name="l1_general_counters_data_high_ext" descr="" subnode="l1_general_counters_data_high_ext" offset="0x0.0" selected_by="L1_General_counters_Data_High" size="0x80.0" />
	<field name="histogram_couters_ext" descr="" subnode="histogram_couters_ext" offset="0x0.0" selected_by="FEC_Histogram_group" size="0xa8.0" />
</node>

<node name="rtpcnt_reg_ext" descr="" size="0x100.0" >
	<field name="grp" descr="performance counter group:\;0x0: Physical_Layer_Error_Counters\;0x1: L1_General_counters_Data_Low\;0x2: L1_General_counters_Data_High\;0x3: FEC_Histogram_group" access="INDEX" enum="Physical_Layer_Error_Counters=0x0,L1_General_counters_Data_Low=0x1,L1_General_counters_Data_High=0x2,FEC_Histogram_group=0x3" offset="0x0.0" size="0x0.2" />
	<field name="data_path" descr="Data Path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="side_sel" descr="0x00: host side\;0x01: line side" access="INDEX" offset="0x0.24" size="0x0.1" />
	<field name="clr" descr="Clear counters. Setting the clr bit will reset the counter value for all counters in the counter group. This bit can be set for both Set() and Get() operation." access="OP" offset="0x4.31" size="0x0.1" />
	<field name="counter_set" descr="Table 925, &quot;Physical Layer Error Counters Fields Layout,&quot; on page 1014\;Table 927, &quot;L1 General counters Data Low Layout,&quot; on page 1016\;Table 929, &quot;L1 General counters Data High Layout,&quot; on page 1019\;Table 931, &quot;FEC Histogram counters Layout,&quot; on page 1022" subnode="rtpcnt_reg_counter_set_auto_ext" access="RO" offset="0x8.0" size="0xf8.0" union_selector="$(parent).grp" />
</node>

<node name="rtpplr_reg_ext" descr="" size="0xc.0" >
	<field name="data_path" descr="Data Path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="sim_cap" descr="This bit-mask indicate sif there is a capability for simultaneous loopbacks on both host and line side\;0: not supported\;1: supported \;\;Bit 0: Crossbar_loopbacks\;Bit 1: FED_loopbacks\;Bit 2: FEA_loopbacks" access="RO" offset="0x4.0" size="0x0.3" />
	<field name="lb_cap" descr="Loopback application capability (bit-mask)\;bit 0: Crossbar_Line_loopback\;bit 1: Crossbar_Host_loopback\;Bit 2: NED_Line_loopback - Tx to Rx on Line side PHY\;Bit 3: NEA_Line_loopback\;Bit 4: NED_Host_loopback\;Bit 5: NED_Host_loopback\;Bit 6: FED_Line_loopback\;Bit 7: FEA_Line_loopback\;Bit 8: FED_Host_loopback\;Bit 9: FEA_Host_loopback\;\;Note:\;NEA - Tx to Rx on analog PHY\;NED - Tx to Rx on digital PHY\;FEA - Rx to Tx on analog PHY\;FED - Rx to Tx on digital PHY\;" access="RO" offset="0x4.16" size="0x0.16" />
	<field name="lb_admin" descr="Set Loopback application (bit-mask)\;multiple loopback configuration (more than one bit set) needs to be allowed by sim_cap field, else get error config\;bit 0: Crossbar_Line_loopback\;bit 1: Crossbar_Host_loopback\;Bit 2: NED_Line_loopback - Tx to Rx on Line side PHY\;Bit 3: NEA_Line_loopback\;Bit 4: NED_Host_loopback\;Bit 5: NED_Host_loopback\;Bit 6: FED_Line_loopback\;Bit 7: FEA_Line_loopback\;Bit 8: FED_Host_loopback\;Bit 9: FEA_Host_loopback" access="RW" offset="0x8.0" size="0x0.16" />
	<field name="lb_oper" descr="Loopback operational mode (bit-mask)\;if the bit is &apos;1&apos; then the loopback is active\;bit 0: Crossbar_Line_loopback\;bit 1: Crossbar_Host_loopback\;Bit 2: NED_Line_loopback - Tx to Rx on Line side PHY\;Bit 3: NEA_Line_loopback\;Bit 4: NED_Host_loopback\;Bit 5: NED_Host_loopback\;Bit 6: FED_Line_loopback\;Bit 7: FEA_Line_loopback\;Bit 8: FED_Host_loopback\;Bit 9: FEA_Host_loopback" access="RO" offset="0x8.16" size="0x0.16" />
</node>

<node name="rtpprt_reg_ext" descr="" size="0x34.0" >
	<field name="le" descr="ignore if ls=0\;0: No per lane configuration, all PPTT configurations are taking place on all lanes of this data path.\;1: Per lane configurations, configurations are taking place per lane based on lane index.\;\;Relevant for set operation only." access="OP" offset="0x0.3" size="0x0.1" />
	<field name="ls" descr="Per Lane configuration support/capability:\;0: No support of per lane configuration\;1: Support of per lane configuration" access="RO" offset="0x0.4" size="0x0.1" />
	<field name="en" descr="Enable PRBS test mode bit:\;0: PRBS Rx is disabled.\;1: PRBS Rx is enabled." access="RW" offset="0x0.5" size="0x0.1" />
	<field name="data_path" descr="Data Path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="direction_sel" descr="Select data path side:\;bit 0: Host \;bit 1: Line" access="INDEX" enum="Host=0x1,Line=0x2" offset="0x0.24" size="0x0.2" />
	<field name="lane" descr="Reserved when (le=0 or ls = 0)\;Logical lane number to configure" access="INDEX" offset="0x0.26" size="0x0.4" />
	<field name="prbs_config_cap" descr="PRBS configuration capabilities (bit-mask)\;\;0: disable; 1:enable\;\;bit 0: polarity\; PRBS TX polarity - (NOT gate in PRBS) (not on the Physical Polarity)\;\;bit 1: MSB&lt;-&gt;LSB swap\;\;bit 2: precoding\;\;bit 3: modulation\;0: NRZ modulation\;1: PAM4 modulation\;\;bit 4: gray codding \;0: unable \;1: able \;\;" access="RO" offset="0x4.0" size="0x0.7" />
	<field name="prbs_config_admin" descr="Set configuration for the PRBS (bit-mask)\;0: disable; 1:enable\;\;bit 0: polarity\; PRBS TX polarity - (NOT gate in PRBS) (not on the Physical Polarity)\;\;bit 1: MSB&lt;-&gt;LSB swap\;(relevant for PAM4 only)\;\;bit 2: precoding\;(relevant for PAM4 only)\;\;bit 3: modulation\;0: NRZ modulation\;1: PAM4 modulation\;\;bit 4: gray codding \;0: disable gray codding\;1: enable gray codding\;\;bit 6: start tuning\; start RX_tuning based on PRBS pattern\;Note: assuming peer transmitting PRBS.\;cannot be set when prbs_rx_tuning_status = 1 (during tuning)\;" access="RW" offset="0x4.11" size="0x0.7" />
	<field name="prbs_mode_cap" descr="PRBS modes capabilities (bit-mask)\;bit 0: PRBS 31 - x^31 + x^28 + 1 \;bit 1: PRBS 23A - x^23 + x^18 + 1 \;bit 2: PRBS 23B - x^23 + x^18 + x^12 + x^6 +1 \;bit 3: PRBS 23C - x^23 + x^22 + x^19 + x^18 +1 \;bit 4: PRBS 23D - x^23 + x^19 + x^18 + x^11 +1 \;bit 5: PRBS 7 - x^7  + x^6  + 1 \;bit 6: PRBS 11 - x^11 + x^9  + 1 \;bit 7: PRBS 11A - x^11 + x^10 + x^6 + x^5 + 1 \;bit 8: PRBS 11B - x^11 + x^9 + x^6 + x^5 + 1 \;bit 9: PRBS 11C - x^11 + x^8 + x^6 + x^4 + 1 \;bit 10: PRBS 11D - x^11 + x^7 + x^6 + x^4 + 1 \;bit 11: PRBS 9 - x^9  + x^5  + 1 \;bit 12-16: reserved\;bit 17: PRBS 13A - x^13+x^12+x^2+x+1 \;bit 18: PRBS 13B - x^13+x^7+x^3+x^2+1 \;bit 19: PRBS 13C - x^13+x^8+x^4+x^2+1 \;bit 20: PRBS 13D - x^13+x^9+x^5+x^2+1\;bit 21: reserved\;bit 22: SSPRQ\;bit 23: reserved\;bit 24: PRBS 15 - x^15 +x^14 + 1\;bit 25: reserved\;bit 26: Square Wave 3\;bit 27: Square Wave 13\;bit 28: Square Wave 30" access="RO" offset="0x8.0" size="0x4.0" />
	<field name="prbs_mode_cap_ex" descr="Extended PRBS modes capabilities (bit-mask)\;bit 0: Square Wave 1\;bit 1: Square Wave 2\;bit 2: Square Wave 4\;bit 3: Square Wave 8\;bit 4: send ones" access="RO" offset="0xC.0" size="0x4.0" />
	<field name="prbs_mode_admin" descr="Select PRBS application\;same encoding as prbs_modes_cap and prbs_modes_cap_ex" access="RW" offset="0x10.0" size="0x0.7" />
	<field name="lane_rate_cap" descr="Rate capability for PRBS (bit-mask):\;Bit 0 - 1GE (1.25 Gb/s)Bit 1 - SDR (2.5 Gb/s)Bit 2 - XAUI/2.5GE (3.125 Gb/s)Bit 3- DDR (5 Gb/s)Bit 4- QDR (10 Gb/s)Bit 5- FDR10 / 10GE/40GE (10.3125 Gb/s)Bit 6- FDR (14.0625 Gb/s)Bit 7- EDR / 25GE / 50GE / 100GE (25.78125 Gb/s)Bit 8 - 50GE-KR4 (12.89 Gb/s)Bit 9 - HDR /50GE / 100GE / 200GE / 400GE (26.5625Gbd /53.125Gb/s)Bit 10 - NDR /100GE / 200GE / 400GE / 800GE (53.125 Gbd /106.25Gb/s)Bit 11 - XDR (106.25Gbd / 212.5Gb/s)" access="RO" offset="0x14.0" size="0x0.16" />
	<field name="auto_pol_rev_fix_cap" descr="When set, Auto polarity and reversal fix flow is possible.\;In order to set if flow is enabled or not, set auto_pol_rev_-\;fix_en field" access="RO" offset="0x14.31" size="0x0.1" />
	<field name="lane_rate_admin" descr="Set rate for PRBS\;Same encoding as in lane rate_cap" access="RW" offset="0x18.0" size="0x0.16" />
	<field name="auto_pol_rev_fix_en" descr="0 - Auto polarity and reversal fix flow will be skipped.\;Field is ignored if auto_pol_rev_fix_cap is not set\;1 - Auto polarity and reversal fix flow will be performed prior to tuning.\;\;Note:\;Auto polarity and reversal process requires sync between both sides. Hence, it is required to set auto_pol_rev_fix_en in both sides for it to work.\;Requires both Rx and Tx to be set and work on both sides.\;auto polarity will fix physical board polarity, but not PRBS polarity. in order to control PRBS polarity manually set &apos;p&apos; field." access="RW" offset="0x18.31" size="0x0.1" />
	<field name="prbs_lock_status" descr="lock on PRBS pattern status for all the data path lanes\;i.e: if the data path is x4, then only bit 0-3 are relevant and ignore 4-7.\;0: no lock\;1: lock acquired" access="RO" offset="0x1C.0" size="0x0.8" />
	<field name="prbs_tuning_status" descr="Tuning status:\;0: PRBS mode tuning was not performed.\;1: Performing PRBS mode tuning.\;2: PRBS mode tuning completed.\;3: Signal Detect in progress\;Note: Once exiting prbs test mode the prbs_rx_tuning_status will return to 0." access="RO" offset="0x1C.8" size="0x0.4" />
</node>

<node name="rtpptt_reg_ext" descr="" size="0x1c.0" >
	<field name="le" descr="ignore if ls=0\;0: No per lane configuration, all PPTT configurations are taking place on all lanes of this data path.\;1: Per lane configurations, configurations are taking place per lane based on lane index.\;\;Relevant for set operation only." access="OP" offset="0x0.3" size="0x0.1" />
	<field name="ls" descr="Per Lane configuration support/capability:\;0: No support of per lane configuration\;1: Support of per lane configuration" access="RO" offset="0x0.4" size="0x0.1" />
	<field name="en" descr="Enable PRBS test mode bit:\;0: PRBS Tx is disabled.\;1: PRBS Tx is enabled." access="RW" offset="0x0.5" size="0x0.1" />
	<field name="data_path" descr="Data Path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="direction_sel" descr="Select data path side:\;bit 0: Host side\;bit 1: Line side" access="INDEX" offset="0x0.24" size="0x0.2" />
	<field name="lane" descr="Reserved when (le=0 or ls = 0)\;Logical lane number to configure" access="INDEX" offset="0x0.26" size="0x0.4" />
	<field name="prbs_config_cap" descr="PRBS configuration capabilities (bit-mask)\;\;0: disable; 1:enable\;\;bit 0: polarity\; PRBS TX polarity - (NOT gate in PRBS) (not on the Physical Polarity)\;\;bit 1: MSB&lt;-&gt;LSB swap\;\;bit 2: precoding\;\;bit 3: modulation\;0: NRZ modulation\;1: PAM4 modulation\;\;bit 4: gray codding\;0: unable\;1: able\;\;bit 7: start tuning\; start RX_tuning based on PRBS pattern\;Note: assuming peer transmitting PRBS.\;cannot be set when prbs_rx_tuning_status = 1 (during tuning)" access="RO" offset="0x4.0" size="0x0.7" />
	<field name="prbs_config_admin" descr="Set configuration for the PRBS (bit-mask)\;0: disable; 1:enable\;\;bit 0: polarity\; PRBS TX polarity - (NOT gate in PRBS) (not on the Physical Polarity)\;\;bit 1: MSB&lt;-&gt;LSB swap\;(relevant for PAM4 only)\;\;bit 2: precoding\;(relevant for PAM4 only)\;\;bit 3: modulation\;0: NRZ modulation\;1: PAM4 modulation\;\;bit 4: gray codding \;0: disable gray codding\;1: enable gray codding" access="RW" offset="0x4.11" size="0x0.7" />
	<field name="prbs_mode_cap" descr="PRBS modes capabilities (bit-mask)\;bit 0: PRBS 31 - x^31 + x^28 + 1 \;bit 1: PRBS 23A - x^23 + x^18 + 1 \;bit 2: PRBS 23B - x^23 + x^18 + x^12 + x^6 +1 \;bit 3: PRBS 23C - x^23 + x^22 + x^19 + x^18 +1 \;bit 4: PRBS 23D - x^23 + x^19 + x^18 + x^11 +1 \;bit 5: PRBS 7 - x^7  + x^6  + 1 \;bit 6: PRBS 11 - x^11 + x^9  + 1 \;bit 7: PRBS 11A - x^11 + x^10 + x^6 + x^5 + 1 \;bit 8: PRBS 11B - x^11 + x^9 + x^6 + x^5 + 1 \;bit 9: PRBS 11C - x^11 + x^8 + x^6 + x^4 + 1 \;bit 10: PRBS 11D - x^11 + x^7 + x^6 + x^4 + 1 \;bit 11: PRBS 9 - x^9  + x^5  + 1 \;bit 12-16: reserved\;bit 17: PRBS 13A - x^13+x^12+x^2+x+1 \;bit 18: PRBS 13B - x^13+x^7+x^3+x^2+1 \;bit 19: PRBS 13C - x^13+x^8+x^4+x^2+1 \;bit 20: PRBS 13D - x^13+x^9+x^5+x^2+1\;bit 21: reserved\;bit 22: SSPRQ\;bit 23: reserved\;bit 24: PRBS 15 - x^15 +x^14 + 1\;bit 25: reserved\;bit 26: Square Wave 3\;bit 27: Square Wave 13\;bit 28: Square Wave 30" access="RO" offset="0x8.0" size="0x4.0" />
	<field name="prbs_mode_cap_ex" descr="Extended PRBS modes capabilities (bit-mask)\;bit 0: Square Wave 1\;bit 1: Square Wave 2\;bit 2: Square Wave 4\;bit 3: Square Wave 8\;bit 4: send ones" access="RO" offset="0xC.0" size="0x4.0" />
	<field name="prbs_mode_admin" descr="Select PRBS application\;same encoding as prbs_modes_cap and prbs_modes_cap_ex" access="RW" offset="0x10.0" size="0x0.7" />
	<field name="lane_rate_cap" descr="Rate capability for PRBS (bit-mask):\;Bit 0 - 1GE (1.25 Gb/s)Bit 1 - SDR (2.5 Gb/s)Bit 2 - XAUI/2.5GE (3.125 Gb/s)Bit 3- DDR (5 Gb/s)Bit 4- QDR (10 Gb/s)Bit 5- FDR10 / 10GE/40GE (10.3125 Gb/s)Bit 6- FDR (14.0625 Gb/s)Bit 7- EDR / 25GE / 50GE / 100GE (25.78125 Gb/s)Bit 8 - 50GE-KR4 (12.89 Gb/s)Bit 9 - HDR /50GE / 100GE / 200GE / 400GE (26.5625Gbd /53.125Gb/s)Bit 10 - NDR /100GE / 200GE / 400GE / 800GE (53.125 Gbd /106.25Gb/s)Bit 11 - XDR (106.25Gbd / 212.5Gb/s)" access="RO" offset="0x14.0" size="0x0.16" />
	<field name="lane_rate_admin" descr="Set rate for PRBS\;Same encoding as in lane rate_cap" access="RW" offset="0x18.0" size="0x0.16" />
</node>

<node name="rtpsl_l1_configuration_ext" descr="" size="0x10.0" >
	<field name="write_en" descr="unless this bit is set to &apos;1&apos; no data can be written to the fields below (use for setting l1_en only):\;0x0: disable\;0x1: enable" access="RW" offset="0x0.0" size="0x0.1" />
	<field name="l1_en" descr="enable L1 feature:\;0x0: disable\;0x1: enable" access="RW" offset="0x0.31" size="0x0.1" />
	<field name="l1_peq_recal_period_cap" descr="The time gap between two consecutive periodic recalibration periods.\;Represents min between host and line side requirements\; 1024 nano sec resolution." access="RO" offset="0x4.0" size="0x0.16" />
	<field name="l1_min_linkup_time_cap" descr="This timer represents the minimum time required to stay in the Linkup state after the local port exits from the L1 state and before it can enter the L1 state again. \;Represents max between host and line side requirements.\;The timer is in 1024 nano sec resolution." access="RO" offset="0x4.16" size="0x0.16" />
	<field name="l1_peq_recal_duration_cap" descr="The time for a single PEQ duration capability. \;Represents min between host and line side requirements\;1024 nano sec resolution." access="RO" offset="0x8.0" size="0x0.16" />
	<field name="l1_peq_recal_period_admin" descr="The time gap between two consecutive periodic recalibration periods\; 1024 nano sec resolution." access="RW" offset="0xC.0" size="0x0.16" />
</node>

<node name="rtpsl_l1_debug_ext" descr="" size="0x20.0" >
	<field name="l1_fsm_stat_h0" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x0.0" size="0x0.4" />
	<field name="l1_fsm_stat_h1" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x0.4" size="0x0.4" />
	<field name="l1_fsm_stat_h2" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x0.8" size="0x0.4" />
	<field name="l1_fsm_stat_h3" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x0.12" size="0x0.4" />
	<field name="l1_fsm_stat_h4" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x0.16" size="0x0.4" />
	<field name="l1_fsm_stat_h5" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x0.20" size="0x0.4" />
	<field name="l1_fsm_stat_h6" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x0.24" size="0x0.4" />
	<field name="l1_fsm_stat_h7" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" enum="FORWARD_DATA=0x0,PROPAGATE=0x1,QUIT_ENTRY=0x2,QUIT=0x3,WAKE=0x4,WAIT_ANNONCE=0x5,WAIT_DATA=0x6,WAIT_CDR=0x8,PWD_PROPAGATE=0x9,DISABLED=0xa" offset="0x0.28" size="0x0.4" />
	<field name="l1_fsm_stat_l0" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x4.0" size="0x0.4" />
	<field name="l1_fsm_stat_l1" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x4.4" size="0x0.4" />
	<field name="l1_fsm_stat_l2" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x4.8" size="0x0.4" />
	<field name="l1_fsm_stat_l3" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x4.12" size="0x0.4" />
	<field name="l1_fsm_stat_l4" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x4.16" size="0x0.4" />
	<field name="l1_fsm_stat_l5" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x4.20" size="0x0.4" />
	<field name="l1_fsm_stat_l6" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x4.24" size="0x0.4" />
	<field name="l1_fsm_stat_l7" descr="L1 state machine\;0x0: FORWARD_DATA\;0x1: PROPAGATE\;0x2: QUIT_ENTRY\;0x3: QUIT\;0x4: WAKE\;0x5: WAIT_ANNONCE\;0x6: WAIT_DATA\;0x7 ENABLE_CDR\;0x8: WAIT_CDR\;0x9: PWD_PROPAGATE\;0xa: DISABLED" access="RO" offset="0x4.28" size="0x0.4" />
	<field name="announce_check_delay" descr="delay before checking for announce after detecting poke.\;64 nanosecond granularity." access="RO" offset="0x8.0" size="0x0.8" />
	<field name="propagation_delay" descr="delay before entering L1 after pattern is detected.\;64 nanosecond granularity." access="RO" offset="0x8.8" size="0x0.8" />
	<field name="pattern_sync_limit" descr="number of pattern sync frame matches to enter L1" access="RO" offset="0x8.16" size="0x0.8" />
	<field name="min_time_to_send_announce" descr="the minimum time that TX will send announce before sending high speed data. \;64 nanosecond granularity." access="RO" offset="0x8.24" size="0x0.8" />
	<field name="shutdown_propagation_delay" descr="Set the delay before shuting down the lane after pattern is detected\;64 nanosecond granularity." access="RO" offset="0xC.0" size="0x0.8" />
	<field name="cdr_lock_delay" descr="Allows for extra delay to be added before frac_n clock control loop starts locking" access="RO" offset="0xC.8" size="0x0.8" />
	<field name="l1_idle_status_annonce_limit" descr="Set number of cycle the idle status must be unset to be considred detected annonce pattern" access="RO" offset="0xC.16" size="0x0.8" />
	<field name="l1_idle_status_poke_limit" descr="Set number of cycle the idle status must be unset to be considred detected poke" access="RO" offset="0xC.24" size="0x0.8" />
	<field name="pattern_to_check" descr="configure the pattern to check" access="RO" offset="0x10.0" size="0x4.0" />
	<field name="cause_go_quit_host" descr="causes are lane bit-mask" access="RO" offset="0x14.0" size="0x0.8" />
	<field name="cause_go_quit_line" descr="causes are lane bit-mask" access="RO" offset="0x14.16" size="0x0.8" />
	<field name="cause_wake_host" descr="causes are lane bit-mask" access="RO" offset="0x18.0" size="0x0.8" />
	<field name="cause_wake_line" descr="causes are lane bit-mask" access="RO" offset="0x18.16" size="0x0.8" />
	<field name="cause_powergov_timeout_host" descr="causes are lane bit-mask" access="RO" offset="0x1C.0" size="0x0.8" />
	<field name="cause_powergov_timeout_line" descr="causes are lane bit-mask" access="RO" offset="0x1C.16" size="0x0.8" />
</node>

<node name="rtpsl_reg_ext" descr="" size="0x100.0" >
	<field name="l1_cap" descr="L1 capability per speed\;Bit 0: xdr_l1_supported" access="RO" offset="0x0.0" size="0x0.4" />
	<field name="data_path" descr="data path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="page_sel" descr="page select:\;0x0: L1_Configurations\;0x1: L1_Debug" access="INDEX" enum="L1_Configurations=0x0,L1_Debug=0x1" offset="0x4.0" size="0x0.5" />
	<field name="page_data" descr="Table 889, &quot;RTPSL - L1 Configurations Layout,&quot; on page 971\;Table 891, &quot;RTPSL - L1 Debug Layout,&quot; on page 972" subnode="rtpsl_reg_page_data_auto_ext" access="RW" offset="0x8.0" size="0xf8.0" union_selector="$(parent).page_sel" />
</node>

<node name="rtpsl_reg_page_data_auto_ext" descr="" attr_is_union="1" size="0x20.0" >
	<field name="rtpsl_l1_configuration_ext" descr="" subnode="rtpsl_l1_configuration_ext" offset="0x0.0" selected_by="L1_Configurations" size="0x10.0" />
	<field name="rtpsl_l1_debug_ext" descr="" subnode="rtpsl_l1_debug_ext" offset="0x0.0" selected_by="L1_Debug" size="0x20.0" />
</node>

<node name="rtptpr_reg_ext" descr="" size="0xc.0" >
	<field name="board_media_type" descr="Indication for the kind of medium for the data.\;For on board retimer\;0: C2C short\;1: C2C long \;2: C2M \;3: Backplane\;4: Passive_copper\;5: Optical_Media" access="RW" offset="0x0.0" size="0x0.3" />
	<field name="transceiver_media_type" descr="Indication for the kind of media medium (including peer side)\;For retimed transceiver \;0x0: C2M_short\;0x1: C2M_long\;0x2: Copper_retimed\;0x3: Optical_retimed\;0x4: Optical_Did" access="RW" enum="C2M_short=0x0,C2M_long=0x1,Copper_retimed=0x2,Optical_retimed=0x3,Optical_Did=0x4" offset="0x0.5" size="0x0.3" />
	<field name="laser_tec" descr="indicate the output optical technology on the current module\;0x0: N/A\;0x1: Vcsel\;0x2: EML\;0x3: Sip" access="RW" enum="N_A=0x0,Vcsel=0x1,EML=0x2,Sip=0x3" offset="0x0.9" size="0x0.2" />
	<field name="data_path" descr="Data Path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="side_sel" descr="select data path side \;0: host side\;1: line side" access="INDEX" offset="0x0.24" size="0x0.1" />
	<field name="attenuation_12g" descr="Attenuation - total channel attenuation @ 12GHz in db.\;A 0 value implies that attenuation_5g is used also for 12GHz" access="RW" offset="0x4.0" size="0x0.8" />
	<field name="attenuation_7g" descr="Attenuation - total channel attenuation @ 7GHz in db.\;A 0 value implies that attenuation_5g is used also for 7GHz" access="RW" offset="0x4.10" size="0x0.8" />
	<field name="attenuation_5g" descr="Attenuation - total channel attenuation @ 5GHz in db." access="RW" offset="0x4.20" size="0x0.8" />
	<field name="attenuation_53g" descr="Attenuation - total channel attenuation @ 53GHz in db.\;A 0 value implies that attenuation_5g is used also for 53GHz" access="RW" offset="0x8.10" size="0x0.8" />
	<field name="attenuation_25g" descr="Attenuation - total channel attenuation @ 25GHz in db.\;A 0 value implies that attenuation_5g is used also for 25GHz" access="RW" offset="0x8.20" size="0x0.8" />
</node>

<node name="rtptys_reg_ext" descr="" size="0x24.0" >
	<field name="data_path" descr="Data Path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="side_sel" descr="select which side of the data path to address (bit- mask):\;bit 0: Ingress\;bit 1: Egress" access="INDEX" enum="Ingress=0x1,Egress=0x2" offset="0x0.24" size="0x0.2" />
	<field name="lt_cap_xdr" descr="Link Training Capability (For 200GB/s only) (bit-mask)\;bit 0: host side\;bit 1: line side" access="RO" offset="0x4.0" size="0x0.2" />
	<field name="lt_en" descr="Link Training enable (bit-mask)\;bit 0: enable host side LT\;bit 1: enable line side LT\;ignore if the capability bit is 0." access="RW" offset="0x4.3" size="0x0.2" />
	<field name="operation_mode" descr="select operation mode:\;0x0: Firmware_autonomous\;The received command may trigger FW state machines and will execute additional commands. (will be used for operational mode)\;0x1: command_explicit\;The Retimer will execute only the received command. (will be used for debugging)" access="RW" enum="command_explicit=0x1" offset="0x4.14" size="0x0.1" />
	<field name="gb_rtm_sel" descr="Select operational mode\;0: No_Change\;1:Gearbox - ignore Retimer fields\;2: Retimer - ignore Gearbox fields" access="INDEX" enum="No_Change=0x0,Gearbox=0x1,Retimer=0x2" offset="0x4.16" size="0x0.2" />
	<field name="rtm_app_capability" descr="Retimer application supported (bit-mask)\;bit 0: 1 x 312.5 Mhz\;bit 1: 2 x 312.5 Mhz\;bit 2: 4 x 312.5 Mhz\;bit 3: 8 x 312.5 Mhz\;bit 4: 1 x 2.5GB/s\;bit 5: 2 x 2.5GB/s\;bit 6: 4 x 2.5GB/s\;bit 7: 8 x 2.5GB/s\;bit 8: 1 x 25GB/s \;bit 9: 2 x 25GB/s\;bit 10: 4 x 25GB/s\;bit 11: 8 x 25GB/s\;bit 12: 1 x 50GB/s\;bit 13: 2 x 50GB/s\;bit 14: 4 x 50GB/s\;bit 15: 8 x 50GB/s\;bit 16: 1 x 100GB/s\;bit 17: 2 x 100GB/s\;bit 18: 4 x 100GB/s\;bit 19: 8 x 100GB/s\;bit 20: 1 x 200GB/s\;bit 21: 2 x 200GB/s\;bit 22: 4 x 200GB/s\;bit 23: 8 x 200GB/s\;bit 24: 1 x detection\;bit 25: 2 x detection\;bit 26: 4 x detection\;bit 27: 8 x detection" access="RO" offset="0x8.0" size="0x4.0" />
	<field name="gb_app_capability" descr="Gearbox application supported (bit-mask)\;bit 0: GB_APP0: 1x200G &lt;-&gt; 2x100G" access="RO" offset="0x10.0" size="0x4.0" />
	<field name="rtm_app_admin" descr="Set the app of the datapath\;Same encoding as capability fields" access="RW" offset="0x14.0" size="0x4.0" />
	<field name="gb_app_admin" descr="Set the requested gearbox application for the datapath\;Same encoding as capability fields" access="RW" offset="0x18.0" size="0x4.0" />
	<field name="rtm_app_oper" descr="Read the current app of the datapath\;Same encoding as capability fields\;ignore if side_sel==0x3" access="RO" offset="0x1C.0" size="0x4.0" />
	<field name="gb_app_oper" descr="Read the current app of the datapath\;Same encoding as capability fields\;ignore if side_sel==0x3" access="RO" offset="0x20.0" size="0x4.0" />
</node>

<node name="rtsfc_reg_ext" descr="" size="0x100.0" >
	<field name="data_path" descr="Data Path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="side_sel" descr="select which side of the data path to address (bit- mask):\;bit 0: host_side\;bit 1: line_side" access="INDEX" enum="host_side=0x1,line_side=0x2" offset="0x0.24" size="0x0.2" />
	<field name="rxtx" descr="for set operation, side bitmask:\;bit 0: rx side\;bit 1: tx side\;for query operation, one-hot key (only one of them can be set)." access="INDEX" offset="0x0.30" size="0x0.2" />
	<field name="page_sel" descr="page select:\;0x01: SFEC_Configurations\;0x01: SFEC_Rx_Debug\;0x02: SFEC_Tx_Debug" access="INDEX" enum="SFEC_Configurations=0x1,SFEC_Rx_Debug=0x1,SFEC_Tx_Debug=0x2" offset="0x4.0" size="0x0.5" />
	<field name="page_data" descr="Table 901, &quot;SFEC Configuration Layout,&quot; on page 985\;Table 903, &quot;SFEC Rx Debug Layout,&quot; on page 986\;Table 905, &quot;SFEC Tx Debug Layout,&quot; on page 988" subnode="rtsfc_reg_page_data_auto_ext" access="RW" offset="0x8.0" size="0xf8.0" union_selector="$(parent).page_sel" />
</node>

<node name="rtsfc_reg_page_data_auto_ext" descr="" attr_is_union="1" size="0x18.0" >
	<field name="rtsfc_sfec_configuration_ext" descr="" subnode="rtsfc_sfec_configuration_ext" offset="0x0.0" selected_by="SFEC_Configurations" size="0x8.0" />
	<field name="rtsfc_sfec_rx_debug_ext" descr="" subnode="rtsfc_sfec_rx_debug_ext" offset="0x0.0" selected_by="SFEC_Rx_Debug" size="0x18.0" />
	<field name="rtsfc_sfec_tx_debug_ext" descr="" subnode="rtsfc_sfec_tx_debug_ext" offset="0x0.0" selected_by="SFEC_Tx_Debug" size="0x8.0" />
</node>

<node name="rtsfc_sfec_configuration_ext" descr="" size="0x8.0" >
	<field name="decoding_type_cap" descr="Decoding type capability bit-mask\;Bit 0: soft decoding (SD FEC)\;Bit 1: hard decoding (HD FEC)" access="RO" offset="0x0.0" size="0x0.2" />
	<field name="decoding_type_admin" descr="set decoding type option:\;0x00: soft decoding (SD FEC)\;0x01: hard decoding (HD FEC)" access="RW" offset="0x0.5" size="0x0.2" />
	<field name="ham_inter_size_cap" descr="hamming interleaver size capability bit-mask:\;Bit 0: 1 way interleaver\;Bit 1: 8 ways interleaver" access="RO" offset="0x0.10" size="0x0.2" />
	<field name="ham_inter_size_admin" descr="set hamming interleaver size:\;0x00: 1 way interleaver\;0x01: 8 ways interleaver" access="RW" offset="0x0.15" size="0x0.2" />
	<field name="padding_blocks_cap" descr="padding block capability bit-mask:\;Bit 0: X2 code word size pad (2178 data blocks)\;Bit 1: X8 code word size pad (8712 data blocks)" access="RO" offset="0x0.20" size="0x0.2" />
	<field name="padding_blocks_admin" descr="set padding block option:\;0x01: X2 code word size pad (2178 data blocks)\;0x02: X8 code word size pad (8712 data blocks)" access="RW" offset="0x0.25" size="0x0.2" />
	<field name="en" descr="enable bit. once set to &apos;1&apos; SFEC engine is enabled" access="RW" offset="0x0.31" size="0x0.1" />
	<field name="align_ok" descr="Assert when SFEC alignment lock error rate below threshold." access="RO" offset="0x4.31" size="0x0.1" />
</node>

<node name="rtsfc_sfec_rx_debug_ext" descr="" size="0x18.0" >
	<field name="pll_ui_shift_cnt" descr="Number of PLL ui shift count in total (backward and forward)" access="RO" offset="0x0.0" size="0x0.10" />
	<field name="sfec_align_lock_state" descr="return the status of the SFEC align lock FSM:\;0x00: ALIGN_LOCK_IDLE\;0x01: ALIGN_CHK_RST_EN\;0x02: ALIGN_CHK_RST_DIS\;0x03: WAIT_ALIGN_CHK_END\;0x04: PLL_UI_SHIFT_ADD_EN\;0x05: PLL_UI_SHIFT_ADD_EN_EXT\;0x06: PLL_UI_SHIFT_ADD_DIS\;0x07: PLL_UI_SHIFT_MINUS_EN\;0x08: PLL_UI_SHIFT_MINUS_EN_EXT\;0x09: PLL_UI_SHIFT_MINUS_EN_PRE\;0x0A: PLL_UI_SHIFT_MINUS_EN_2PRE\;0x0B: PLL_UI_SHIFT_MINUS_EN_POST\;0x0C: PLL_UI_SHIFT_MINUS_EN_2POST\;0x0D: PLL_UI_SHIFT_MINUS_DIS\;0x0E: ALIGN_LOCK_OK\;0x0F: ALIGN_LOCK_FAIL" access="RO" enum="ALIGN_LOCK_IDLE=0x0,ALIGN_CHK_RST_EN=0x1,ALIGN_CHK_RST_DIS=0x2,WAIT_ALIGN_CHK_END=0x3,PLL_UI_SHIFT_ADD_EN=0x4,PLL_UI_SHIFT_ADD_EN_EXT=0x5,PLL_UI_SHIFT_ADD_DIS=0x6,PLL_UI_SHIFT_MINUS_EN=0x7,PLL_UI_SHIFT_MINUS_EN_EXT=0x8,PLL_UI_SHIFT_MINUS_EN_PRE=0x9,PLL_UI_SHIFT_MINUS_EN_2PRE=0xa,PLL_UI_SHIFT_MINUS_EN_POST=0xb,PLL_UI_SHIFT_MINUS_EN_2POST=0xc,PLL_UI_SHIFT_MINUS_DIS=0xd,ALIGN_LOCK_OK=0xe,ALIGN_LOCK_FAIL=0xf" offset="0x0.16" size="0x0.4" />
	<field name="align_ok" descr="Assert when SFEC alignment lock error rate below threshold." access="RO" offset="0x0.27" size="0x0.1" />
	<field name="align_lock_ok" descr="Assert when SFEC alignment lock finish and ok." access="RO" offset="0x0.28" size="0x0.1" />
	<field name="align_lock_fail" descr="Assert when SFEC alignment lock finish and failed." access="RO" offset="0x0.29" size="0x0.1" />
	<field name="align_lock_done" descr="Assert when SFEC alignment lock finish." access="RO" offset="0x0.30" size="0x0.1" />
	<field name="clear_flags" descr="when set, all flags clear" access="OP" offset="0x0.31" size="0x0.1" />
	<field name="no_correction" descr="An option to disable the correction of data even when error is detected.\;0x00: correction enable\;0x01: correction disable" access="RW" offset="0x4.0" size="0x0.1" />
	<field name="sfec_nblk_cnt_tc" descr="Total numbers of bit on a window to check the error threshold.\;(numbers of bits)" access="RW" offset="0x8.0" size="0x0.10" />
	<field name="sfec_nblk_cnt_th" descr="Threshold numbers of errors to acquire lock for a window." access="RW" offset="0x8.10" size="0x0.11" />
	<field name="sfec_nerr_cnt" descr="Number of errors. on the current window." access="RO" offset="0x8.21" size="0x0.11" />
	<field name="alignment_marker1" descr="set the alignment marker to look for.\;those are the first 32 bits" access="RW" offset="0xC.0" size="0x4.0" />
	<field name="alignment_marker2" descr="set the alignment marker to look for.\;those are the last 16 bits" access="RW" offset="0x10.0" size="0x0.16" />
	<field name="back_chanel" descr="data that can be inserted as part of the marker.\;the data that was retrieved from the marker (Read Only)" access="RO" offset="0x10.16" size="0x0.16" />
	<field name="bad_marker_count_th" descr="consecutive bad marker threshold for lose of lock\;relevant for Rx side only. for Tx ignore this field." access="RW" offset="0x14.24" size="0x0.4" />
	<field name="marker_detect_nibble_match_th" descr="Configure the amount of nibbles need to be correct from AM in order to be lock\;relevant for Rx side only. for Tx ignore this field." access="RW" offset="0x14.28" size="0x0.4" />
</node>

<node name="rtsfc_sfec_tx_debug_ext" descr="" size="0x8.0" >
	<field name="alignment_marker1" descr="set the alignment marker to insert.\;those are the first 32 bits" access="RW" offset="0x0.0" size="0x4.0" />
	<field name="alignment_marker2" descr="set the alignment marker to insert.\;those are the last 16 bits" access="RW" offset="0x4.0" size="0x0.16" />
	<field name="back_chanel" descr="data that can be inserted as part of the marker.\;enter the data to insert through the marker." access="RW" offset="0x4.16" size="0x0.16" />
</node>

<node name="rttspc_reg_ext" descr="" size="0x4.0" >
	<field name="squelch_ctrl" descr="The behavior of the TX when in TX squelched state:\;0: TX power off\;1: TX in common mode\;2: TX sends PRBS (PRBS31)" access="RW" offset="0x0.0" size="0x0.3" />
	<field name="data_path" descr="Data Path number" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="side_sel" descr="select which side of the data path to address (bit- mask):\;bit 0: Ingress\;bit 1: Egress" access="INDEX" enum="Ingress=0x1,Egress=0x2" offset="0x0.24" size="0x0.2" />
</node>

<node name="slrg_16nm_ext" descr="" size="0x24.0" >
	<field name="grade_lane_speed" descr="The lane speed on which the grade was measured:\;0 - SDR / PCIe Gen 1\;1 - DDR / PCIe Gen 2\;2 - QDR / PCIe Gen 3\;3 - FDR10 (10GE / 40GE)\;4 - FDR (56GE) / PCIe Gen 4\;5 - EDR (25GE / 50GE / 100GE) / PCIe Gen 5\;6 - HDR (50GE / 200GE / 400GE)\;7- 9 - reserved\;10 - 1GE\;11 - 2.5GE (XAUI)\;12 - 50GE-KR4\;13 - 15 - reserved" access="RO" offset="0x0.0" size="0x0.4" />
	<field name="grade" descr="The grade that the lane received based on a specific configuration.\;" access="RO" offset="0x4.0" size="0x0.24" />
	<field name="grade_version" descr="" access="RO" offset="0x4.24" size="0x0.8" />
	<field name="height_eo_neg_up" descr="Voltage offset from eye center to the negative side of the upper eye. Only applicable for PAM4 signal." access="RO" offset="0x8.0" size="0x0.16" />
	<field name="height_eo_pos_up" descr="Voltage offset from eye center to the positive side of the upper eye.\;Only applicable for PAM4 signal." access="RO" offset="0x8.16" size="0x0.16" />
	<field name="height_eo_pos_mid" descr="Voltage offset from eye center to the positive side of the middle eye." access="RO" offset="0xC.0" size="0x0.16" />
	<field name="phase_eo_neg_up" descr="The offset from the eye center to the negative (left) side of the upper eye. Only applicable for PAM4 signal." access="RO" offset="0xC.16" size="0x0.8" />
	<field name="phase_eo_pos_up" descr="The offset from the eye center to the positive (right) side of the upper eye. Only applicable for PAM4 signal." access="RO" offset="0xC.24" size="0x0.8" />
	<field name="phase_eo_neg_mid" descr="The offset from the eye center to the negative (left) side of the middle eye." access="RO" offset="0x10.0" size="0x0.8" />
	<field name="phase_eo_pos_mid" descr="The offset from the eye center to the positive (right) side of the middle eye." access="RO" offset="0x10.8" size="0x0.8" />
	<field name="height_eo_neg_mid" descr="Voltage offset from eye center to the negative side of the middle eye." access="RO" offset="0x10.16" size="0x0.16" />
	<field name="height_eo_neg_low" descr="Voltage offset from eye center to the negative side of the lower eye. Only applicable for PAM4 signal." access="RO" offset="0x14.0" size="0x0.16" />
	<field name="height_eo_pos_low" descr="Voltage offset from eye center to the positive side of the lower eye. Only applicable for PAM4 signal." access="RO" offset="0x14.16" size="0x0.16" />
	<field name="phase_eo_neg_low" descr="The offset from the eye center to the negative (left) side of the lower eye. Only applicable for PAM4 signal." access="RO" offset="0x18.16" size="0x0.8" />
	<field name="phase_eo_pos_low" descr="The offset from the eye center to the positive (right) side of the lower eye. Only applicable for PAM4 signal." access="RO" offset="0x18.24" size="0x0.8" />
	<field name="up_eye_grade" descr="upper eye grade" access="RO" offset="0x1C.0" size="0x0.16" />
	<field name="mid_eye_grade" descr="middle eye grade" access="RO" offset="0x1C.16" size="0x0.16" />
	<field name="dn_eye_grade" descr="lower eye grade" access="RO" offset="0x20.0" size="0x0.16" />
</node>

<node name="slrg_40nm_28nm_ext" descr="" size="0x24.0" >
	<field name="grade_lane_speed" descr="The lane speed on which the grade was measured:\;0 - SDR\;1 - DDR\;2 - QDR\;3 - FDR10 (10GE / 40GE)\;4 - FDR (56GE)\;5 - EDR (25GE / 50GE / 100GE)\;6 - 9 - reserved\;10 - 1GE\;11 - 2.5GE (XAUI)\;12 - 50GE-KR4\;13 - 15 - reserved" access="RO" offset="0x0.0" size="0x0.4" />
	<field name="grade" descr="" access="RO" offset="0x4.0" size="0x0.24" />
	<field name="grade_version" descr="" access="RO" offset="0x4.24" size="0x0.8" />
	<field name="height_eo_neg" descr="Voltage offset from eye center to the negative side." access="RO" offset="0x14.0" size="0x0.16" />
	<field name="height_eo_pos" descr="Voltage offset from eye center to the positive side." access="RO" offset="0x14.16" size="0x0.16" />
	<field name="phase_eo_neg" descr="The offset from the eye center to the negative side." access="RO" offset="0x1C.0" size="0x0.8" />
	<field name="phase_eo_pos" descr="The offset from the eye center to the positive side." access="RO" offset="0x1C.16" size="0x0.8" />
</node>

<node name="slrg_7nm_ext" descr="" size="0x18.0" >
	<field name="fom_measurment" descr="Bitmask for measurement activation\;Bit 0 - Upper eye\;Bit 1 - Middle eye\;Bit 2 - Lower eye\;Bit 3- Composite eye\;Note: NRZ only Bit 3 is valid" access="OP" offset="0x0.0" size="0x0.4" />
	<field name="initial_fom" descr="measured EOM status after FEQ.\;valid only when SLRG.status is &apos;1&apos;" access="RO" offset="0x4.0" size="0x0.8" />
	<field name="fom_mode" descr="fom mode:\;FOM eye mode to search\;0x0: FOM_MODE_EYEC\;0x1: FOM_MODE_EYEO\;0x2: FOM_MODE_EYEM\;0x3: FOM_MODE_BER\;0x4:FOM_MODE_EYEC_VN\;0x5:FOM_MODE_EYEC_VP\;0x6:FOM_MODE_EYEM_VN\;0x7:FOM_MODE_EYEM_VP" access="RO" enum="FOM_MODE_EYEC=0x0,FOM_MODE_EYEO=0x1,FOM_MODE_EYEM=0x2,FOM_MODE_BER=0x3,FOM_MODE_EYEC_VN=0x4,FOM_MODE_EYEC_VP=0x5,FOM_MODE_EYEM_VN=0x6,FOM_MODE_EYEM_VP=0x7" offset="0x4.16" size="0x0.3" />
	<field name="lower_eye" descr="last measured EOM-FOM status of lower eye.\;valid only if fom_measurment bit &apos;2&apos; is set" access="RO" offset="0x8.0" size="0x0.8" />
	<field name="mid_eye" descr="last measured EOM-FOM status of middle eye.\;valid only if fom_measurment bit &apos;1&apos; is set" access="RO" offset="0x8.8" size="0x0.8" />
	<field name="upper_eye" descr="last measured EOM-FOM status of upper eye.\;valid only if fom_measurment bit &apos;0&apos; is set" access="RO" offset="0x8.16" size="0x0.8" />
	<field name="last_fom" descr="last measured EOM-FOM status of composite eye.\;valid only if fom_measurment bit &apos;3&apos; is set" access="RO" offset="0x8.24" size="0x0.8" />
</node>

<node name="slrg_reg_ext" descr="" size="0x28.0" >
	<field name="port_type" descr="For HCA supported only when indicated by PCAM \;0: Network_Port\;1: NearEnd_Port - (For Retimer/Gearbox - Host side)\;2: Internal_IC_LR_Port \;3: FarEnd_Port - (For Retimer/Gearbox - Line side)\;\;" access="INDEX" enum="Network_Port=0x0,NearEnd_Port=0x1,Internal_IC_LR_Port=0x2,FarEnd_Port=0x3" offset="0x0.4" size="0x0.4" />
	<field name="lane" descr="Logical lane number" access="INDEX" offset="0x0.8" size="0x0.4" />
	<field name="lp_msb" descr="Local port number [9:8]" access="INDEX" offset="0x0.12" size="0x0.2" />
	<field name="pnat" descr="Port number access type. \;0 - Local port number\;1 - IB port number\;" access="INDEX" offset="0x0.14" size="0x0.2" />
	<field name="local_port" descr="Local port number." access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="version" descr="0: prod_40nm\;1: prod_28nm\;3: prod_16nm\;4: prod_7nm\;5: prod_5nm" access="RO" enum="prod_40nm=0x0,prod_28nm=0x1,prod_16nm=0x3,prod_7nm=0x4,prod_5nm=0x5" offset="0x0.24" size="0x0.4" />
	<field name="status" descr="0 - Invalid\;1 - Valid\;" access="RO" offset="0x0.28" size="0x0.4" />
	<field name="page_data" descr="Table 594, &quot;SLRG - Serdes Lane Receive Grade Register Layout for 40nm and 28nm,&quot; on page 635\;Table 596, &quot;SLRG - Serdes Lane Receive Grade Register Layout for 16nm,&quot; on page 636\;Table 598, &quot;SLRG - Serdes Lane Receive Grade Register Layout for 7nm and 5nm,&quot; on page 638" subnode="slrg_reg_page_data_auto_ext" access="RO" condition="$(parent).version" offset="0x4.0" size="0x24.0" />
</node>

<node name="slrg_reg_page_data_auto_ext" descr="" attr_is_union="1" is_conditional="1" size="0x24.0" >
	<field name="slrg_40nm_28nm_ext" descr="" subnode="slrg_40nm_28nm_ext" condition="($(parent).port_type == Network_Port AND ($(parent).version == prod_40nm | $(parent).version == prod_28nm)" offset="0x0.0" size="0x24.0" />
	<field name="slrg_16nm_ext" descr="" subnode="slrg_16nm_ext" condition="($(parent).port_type == Network_Port AND ($(parent).version == prod_16nm)" offset="0x0.0" size="0x24.0" />
	<field name="slrg_7nm_ext" descr="" subnode="slrg_7nm_ext" condition="($(parent).port_type == Network_Port) AND (($(parent).version == prod_7nm) || ($(parent).version == prod_5nm))" offset="0x0.0" size="0x18.0" />
</node>

<node name="sltp_16nm_ext" descr="" size="0x48.0" >
	<field name="post_tap" descr="Value of each tap is between -96 to 96\;\;NOTE: The total sum of all absolute taps values should be 96 or smaller.\;" access="RW" offset="0x4.0" size="0x0.8" />
	<field name="main_tap" descr="Value of each tap is between -96 to 96\;\;NOTE: The total sum of all absolute taps values should be 96 or smaller.\;" access="RW" offset="0x4.8" size="0x0.8" />
	<field name="pre_tap" descr="Value of each tap is between -96 to 96\;\;NOTE: The total sum of all absolute taps values should be 96 or smaller.\;" access="RW" offset="0x4.16" size="0x0.8" />
	<field name="pre_2_tap" descr="Value of each tap is between -96 to 96\;\;NOTE: The total sum of all absolute taps values should be 96 or smaller.\;" access="RW" offset="0x4.24" size="0x0.8" />
	<field name="ob_alev_out" descr="Output common mode. Values can be set in the range of (0-30)" access="RW" offset="0x8.0" size="0x0.5" />
	<field name="ob_amp" descr="Output amplitude. Values can be set in the range of (10-100)." access="RW" offset="0x8.8" size="0x0.7" />
	<field name="ob_m2lp" descr="MSB to LSB proportion. \;Values can be set between -10 to 50. \;\;MSB emphasis achieved when value is between -10 to -1 \;LSB emphasis achieved when value is between 1 to 50. \;When set to 0 - equal proportion." access="RW" offset="0x8.25" size="0x0.7" />
	<field name="ob_bad_stat" descr="Bitmask for bad &apos;set&apos; status:\;0: configuration_warning - taps values can&apos;t be set to serdes due to internal limitations. Actual TX configuration is modify internally with the same sum of taps weight.\;11: Illegal_ob_combination - ob_m2lp, ob_amp and ob_alev is in legal range each, but the total combination can&apos;t be set to serdes due to internal limitations, the Set command is ignored.\;12: Illegal_ob_m2lp\;13: Illegal_ob_amp\;14: Illegal_ob_alev_out\;15: Illegal_taps\;\;Bit 12-0 - Reserved /Unknown" access="RO" enum="configuration_warning=0x0,Illegal_ob_combination=0xb,Illegal_ob_m2lp=0xc,Illegal_ob_amp=0xd,Illegal_ob_alev_out=0xe,Illegal_taps=0xf" offset="0xC.16" size="0x0.16" />
	<field name="regp_bfm1n" descr="Values can be set in the range of (0-200)." access="RW" offset="0x10.0" size="0x0.8" />
	<field name="regn_bfm1p" descr="Values can be set in the range of (0-200)." access="RW" offset="0x10.8" size="0x0.8" />
	<field name="obnlev" descr="Values can be set in the range of (0-200)." access="RW" offset="0x10.16" size="0x0.8" />
	<field name="obplev" descr="Values can be set in the range of (0-200)." access="RW" offset="0x10.24" size="0x0.8" />
</node>

<node name="sltp_28nm_40nm_ext" descr="" size="0x48.0" >
	<field name="ob_tap2" descr="\;" access="RW" offset="0x4.0" size="0x0.8" />
	<field name="ob_tap1" descr="\;" access="RW" offset="0x4.8" size="0x0.8" />
	<field name="ob_tap0" descr="\;" access="RW" offset="0x4.16" size="0x0.8" />
	<field name="polarity" descr="Tx lane polarity" access="RW" offset="0x4.24" size="0x0.1" />
	<field name="ob_bias" descr="" access="RW" offset="0x8.0" size="0x0.8" />
	<field name="ob_reg" descr="(ref_txcml100_reg)" access="RW" offset="0x8.8" size="0x0.8" />
	<field name="ob_preemp_mode" descr="Concatenation of taps polarity + preemp_sel" access="RW" offset="0x8.16" size="0x0.4" />
	<field name="ob_leva" descr="" access="RW" offset="0x8.20" size="0x0.4" />
	<field name="ob_bad_stat" descr="Bitmask for bad SET status:\;Bit 0 - Illegal ob_bais value\;Bit 1 - Illegal ob taps polarity (distance between taps)" access="RO" offset="0xC.29" size="0x0.2" />
	<field name="ob_norm" descr="OB Normalization status:\;0 - No Normalization was done\;1 - Normalization performed" access="RO" offset="0xC.31" size="0x0.1" />
</node>

<node name="sltp_7nm_ext" descr="" size="0x48.0" >
	<field name="fir_pre2" descr="Signed value for TX FIR taps.\;tap scaling = fir_tap/63.\;for 100G per lane 5 taps, \;for 50G per lane 4 taps are used (no pre3),\;or 25G per lane 3 taps are used (no pre3,pre2)\;Valid values for taps:\;fir_main [34,63]\;fir_pre1 [-23,0]\;fir_pre2 [0,8]\;fir_pre3 [-5,0]\;fir_post1 [-21,0]\;\;Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| &lt;= 63.\;NRZ speeds must guarantee sum|c(i)| = 63\;Note: Configured taps may get effective value of +/-1 from the value that has been set." access="RW" offset="0x0.0" size="0x0.8" />
	<field name="fir_pre3" descr="Signed value for TX FIR taps.\;tap scaling = fir_tap/63.\;for 100G per lane 5 taps, \;for 50G per lane 4 taps are used (no pre3),\;or 25G per lane 3 taps are used (no pre3,pre2)\;Valid values for taps:\;fir_main [34,63]\;fir_pre1 [-23,0]\;fir_pre2 [0,8]\;fir_pre3 [-5,0]\;fir_post1 [-21,0]\;\;Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| &lt;= 63.\;NRZ speeds must guarantee sum|c(i)| = 63\;Note: Configured taps may get effective value of +/-1 from the value that has been set." access="RW" offset="0x0.8" size="0x0.8" />
	<field name="ob_bad_stat" descr="Bitmask for bad &apos;set&apos; status:\;Bit 0: pre3_is_out_of_range\;Bit 1: pre2_is_out_of_range\;Bit 2: pre1_is_out_of_range\;Bit 3: main_tap_is_out_of_range\;Bit 4: post1_is_out_of_range\;Bit 5: sum_of_taps_is_out_of_range\;Bit 6: taps_not_alinged_with_speed" access="RO" enum="pre3_is_out_of_range=0x1,pre2_is_out_of_range=0x2,pre1_is_out_of_range=0x4,main_tap_is_out_of_range=0x8,post1_is_out_of_range=0x10,sum_of_taps_is_out_of_range=0x20,taps_not_alinged_with_speed=0x40" offset="0x0.16" size="0x0.8" />
	<field name="drv_amp" descr="High speed output driver amplitude settings, default = 6&quot;d63.\; amplitude scaling = (AMP+1) / 64" access="RW" offset="0x0.24" size="0x0.6" />
	<field name="fir_post1" descr="Signed value for TX FIR taps.\;tap scaling = fir_tap/63.\;for 100G per lane 5 taps, \;for 50G per lane 4 taps are used (no pre3),\;or 25G per lane 3 taps are used (no pre3,pre2)\;Valid values for taps:\;fir_main [34,63]\;fir_pre1 [-23,0]\;fir_pre2 [0,8]\;fir_pre3 [-5,0]\;fir_post1 [-21,0]\;\;Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| &lt;= 63.\;NRZ speeds must guarantee sum|c(i)| = 63\;Note: Configured taps may get effective value of +/-1 from the value that has been set." access="RW" offset="0x4.8" size="0x0.8" />
	<field name="fir_main" descr="Signed value for TX FIR taps.\;tap scaling = fir_tap/63.\;for 100G per lane 5 taps, \;for 50G per lane 4 taps are used (no pre3),\;or 25G per lane 3 taps are used (no pre3,pre2)\;Valid values for taps:\;fir_main [34,63]\;fir_pre1 [-23,0]\;fir_pre2 [0,8]\;fir_pre3 [-5,0]\;fir_post1 [-21,0]\;\;Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| &lt;= 63.\;NRZ speeds must guarantee sum|c(i)| = 63\;Note: Configured taps may get effective value of +/-1 from the value that has been set." access="RW" offset="0x4.16" size="0x0.8" />
	<field name="fir_pre1" descr="Signed value for TX FIR taps.\;tap scaling = fir_tap/63.\;for 100G per lane 5 taps, \;for 50G per lane 4 taps are used (no pre3),\;or 25G per lane 3 taps are used (no pre3,pre2)\;Valid values for taps:\;fir_main [34,63]\;fir_pre1 [-23,0]\;fir_pre2 [0,8]\;fir_pre3 [-5,0]\;fir_post1 [-21,0]\;\;Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| &lt;= 63.\;NRZ speeds must guarantee sum|c(i)| = 63\;Note: Configured taps may get effective value of +/-1 from the value that has been set." access="RW" offset="0x4.24" size="0x0.8" />
</node>

<node name="sltp_reg_ext" descr="" size="0x4c.0" >
	<field name="c_db" descr="copy transmitter parameters to Data Base. \;" access="OP" offset="0x0.0" size="0x0.1" />
	<field name="port_type" descr="For HCA supported only when indicated by PCAM \;0: Network_Port\;1: NearEnd_Port - (For Retimer/Gearbox - Host side)\;2: Internal_IC_LR_Port \;3: FarEnd_Port - (For Retimer/Gearbox - Line side)\;\;" access="INDEX" enum="Network_Port=0x0,NearEnd_Port=0x1,Internal_IC_LR_Port=0x2,FarEnd_Port=0x3" offset="0x0.1" size="0x0.3" />
	<field name="lane_speed" descr="Reserved for PCIe.\;The lane speed for TX settings:\;0 - SDR / Gen1 (PCIe)\;1 - DDR / Gen2 (PCIe) / 5GBASE-R\;2 - QDR / Gen3 (PCIe)\;3 - FDR10 (10GE / 40GE)\;4 - FDR (56GE) / Gen4 (PCIe)\;5 - EDR (25GE / 50GE / 100GE) / Gen5 (PCIe)\;6 - HDR (50GE / 200GE / 400GE)\;7 - NDR /100GE / 200GE / 400GE / 800GE (53.125 Gbd / 106.25Gb/s)\;8 - XDR (106.25 Gbd / 212.5Gb/s)\;9 - Reserved\;10 - 1GE\;11 - 2.5GE (XAUI)\;12 - 50GE-KR4\;13-15 - Reserved" access="RW" offset="0x0.4" size="0x0.4" />
	<field name="lane" descr="Logical lane number" access="INDEX" offset="0x0.8" size="0x0.4" />
	<field name="tx_policy" descr="Configures Tx parameter set policy\;0 - Tx parameters will be set according to best possible configuration chosen by the system\;1 - Tx parameters will be set according to Data Base only and will not be overridden by link training (e.g KR-Startup)" access="RW" offset="0x0.13" size="0x0.1" />
	<field name="pnat" descr="Port number access type. determines the way local_port is interpreted:\;0 - Local port number\;1 - IB port number\;" access="INDEX" offset="0x0.14" size="0x0.2" />
	<field name="local_port" descr="Local port number [7:0]\;" access="INDEX" offset="0x0.16" size="0x0.8" />
	<field name="version" descr="0: prod_40nm\;1: prod_28nm\;3: prod_16nm\;4: prod_7nm\;5: prod_5nm" access="RO" enum="prod_40nm=0x0,prod_28nm=0x1,prod_16nm=0x3,prod_7nm=0x4,prod_5nm=0x5" offset="0x0.24" size="0x0.4" />
	<field name="status" descr="Indicates that Tx setting readout is valid and active. In particular, for links that do AN/LT, valid will be set when link operational status is UP (PAOS.oper_status=0x1).\;For links without AN/LT, valid will be set when Tx is enabled.\;\;0 - Invalid\;1 - Valid\;\;Note: Get and Set operations can be set when status = invalid." access="RO" offset="0x0.28" size="0x0.1" />
	<field name="lp_msb" descr="Local port number [9:8]" access="INDEX" offset="0x0.30" size="0x0.2" />
	<field name="page_data" descr="Table 578, &quot;SLTP - Serdes Lane Transmit Parameters Register Layout for 28nm and 40nm,&quot; on page 622\;Table 580, &quot;SLTP - Serdes Lane Transmit Parameters Register Layout for 16nm,&quot; on page 623\;Table 584, &quot;SLTP - Serdes Lane Transmit Parameters Register Layout for 7nm,&quot; on page 625\;" subnode="sltp_reg_page_data_auto_ext" access="RW" condition="$(parent).version" offset="0x4.0" size="0x48.0" />
</node>

<node name="sltp_reg_page_data_auto_ext" descr="" attr_is_union="1" is_conditional="1" size="0x48.0" >
	<field name="sltp_28nm_40nm_ext" descr="" subnode="sltp_28nm_40nm_ext" condition="($(parent).port_type == Network_Port) AND ($(parent).version == prod_40nm | $(parent).version == prod_28nm)" offset="0x0.0" size="0x48.0" />
	<field name="sltp_16nm_ext" descr="" subnode="sltp_16nm_ext" condition="($(parent).port_type == Network_Port | $(parent).port_type == Internal_IC_LR_Port) AND ($(parent).version == prod_16nm)" offset="0x0.0" size="0x48.0" />
	<field name="sltp_7nm_ext" descr="" subnode="sltp_7nm_ext" condition="($(parent).port_type == Network_Port | $(parent).port_type == Internal_IC_LR_Port) AND ($(parent).version == prod_7nm)" offset="0x0.0" size="0x48.0" />
</node>

<node name="uint64" descr="" size="0x8.0" >
	<field name="hi" descr="" offset="0x0.0" size="0x4.0" />
	<field name="lo" descr="" offset="0x4.0" size="0x4.0" />
</node>

<node name="root" size="0x208.0" descr="" >
	<field name="register_access_table_retimer_ext_Nodes" offset="0x0.0" size="0x208.0" subnode="register_access_table_retimer_ext_Nodes" descr="" />
</node>

<node name="register_access_table_retimer_ext_Nodes" size="0x208.0" attr_is_union="1" descr="" >
	<field name="access_reg_summary_selector_ext" offset="0x0.0" size="0x208.0" subnode="access_reg_summary_selector_ext" descr="" />
</node>
</NodesDefinition>
